
% Copied from binary_s1 and modified as needed. For the case where we draw
% the image from the J&S prior.

%resfileInd = [ 1, 6, 7 ];
%resfileInd = [ 6, 5, 3, 4, 10 ];
resfileInd = [ 4 ];
figInd = 1;
errind = 2;

B_LOGY_HYP = 0;

% map_revised: G_SPECIAL = 1/sqrt(2)
% map_revised2: 1e-4
% map_revised3: 0
% map_revised4: 1e4
% map_revised5: 1e3
% map1_fixed: MAP1 with fixed (a,w)
% map2_fixed: MAP2 with G_SPECIAL=0, and fixed (a,w)

resfile = { 'lars_v1.mat', 'map_revised3.mat', 'map_revised.mat', ...
    'map_revised5.mat', 'map1.mat', 'eb_better_nov05.mat', ...
    'eb_fixed.mat', 'map1_fixed.mat', 'map2_fixed.mat', ...
    'lars_v2.mat', 'lars_strat3_mar.mat' };

reconfield = { 'last', 'last', 'last', ...
    'last', 'last', 'last', ...
    'last', 'last', 'last', ...
    'last', 'bestBeta3' };

vecSnrDb = [ 1.76, 3.01, 3.98, 4.77, 7, 10, 13, 20, 16 ];
snrdir = [ 2, 3, 4, 5, 7, 8, 9, 10, 11 ];
snrreal = [ 50, 50, 50, 50, 50, 50, 50, 50, 50; ...
            30, 30, 30, 30, 30, 30, 30, 30, 30; ...
            30, 30, 30, 30, 30, 30, 30, 30, 30; ...
            30, 30, 30, 30, 30, 30, 30, 30, 30; ...
            30, 30, 30, 30, 30, 30, 30, 30, 30; ...
            30, 30, 30, 30, 30, 30, 30, 30, 30; ...
            30, 30, 30, 30, 30, 30, 30, 30, 30; ...
            30, 30, 30, 30, 30, 30, 30, 30, 30; ...
            30, 30, 30, 30, 30, 30, 30, 30, 30; ...
            30, 30, 30, 30, 30, 30, 30, 30, 30; ...
            30, 30, 30, 30, 30, 30, 30, 30, 30 ];

[vecSnrDbSorted, sortedInd] = sort( vecSnrDb );

sszMetricName = { 'l_0(e)', 'E_d', 'l_1(e)', 'hard', 'soft', 'l_2(e)', 'l_0 of estimate' };
%sszPlotColour = { 'rx-', 'gs-', 'b.-', 'kd-', 'mv-' };
%sszPlotColour = { 'kx-.', 'ks--', 'ko-', 'k*:' };
sszPlotColour = { 'rx-.', 'gs--', 'bo-', 'k*:', 'md:' };

if length( resfileInd ) == 1
    
    % Only plot for 1 index
    
    szResfile = char( resfile( resfileInd ) );
    szReconFieldname = char( reconfield( resfileInd ) );
    
    % Construct performance structure
    
    if ~exist( 'sPerfRes', 'var' ), disp( 'Constructing sPerfRes...' );        
        sPerfRes = irecon_collect( 'resfile', szResfile, ...
            'snrdir', snrdir, ...
            'snrreal', snrreal(resfileInd,:), ...
            'spriv', struct( 'szReconFieldname', szReconFieldname ), ...
            'fcncull', 'irecon_perf_cull' );
    else
        disp( 'Reusing sPerfRes' );
    end

    % Plot performance
    
    figure( figInd ), clf;
    m = sPerfRes.mean( :, errind );
    s = sPerfRes.std( :, errind );    
    errorbar( vecSnrDbSorted, m(sortedInd), s(sortedInd) );
    ylabel( char( sszMetricName(errind) ), 'Interpreter', 'none' );
    xlabel( 'snr [dB]' );
    title( sprintf( 'resfile = %s', szResfile ), 'Interpreter', 'none' );
    grid on;
    
    % Construct hyperparameter structure
    
    if ~exist( 'sHypRes', 'var' ), disp( 'Constructing sHypRes...' );
        sHypRes = irecon_collect( 'resfile', szResfile, ...
            'snrdir', snrdir, ...
            'snrreal', snrreal(resfileInd,:), ...
            'spriv', struct, ...
            'fcncull', 'irecon_hyp_cull' );
    else
        disp( 'Reusing sHypRes' );
    end
    
    % Plot hyperparameter 
    
    nHyp = size( sHypRes.mean, 2 );
    if size( sHypRes.std, 2 ) ~= nHyp, error( 'inconsistent size' ), end;
    
    figure( figInd+1 ), clf;   
    if nHyp > 9, error( 'cannot handle nHyp > 9' ), end;
    nWin = 100 + nHyp*10;
    
    for indHyp = 1:nHyp
        subplot( nWin + indHyp );
        m = sHypRes.mean( :, indHyp );
        s = sHypRes.std( :, indHyp );
        if ~B_LOGY_HYP
            errorbar( vecSnrDbSorted, m(sortedInd), s(sortedInd), char(sszPlotColour(indHyp)) );
        else
            errorbar( vecSnrDbSorted, log10(m(sortedInd)), log10(s(sortedInd)), char(sszPlotColour(indHyp)) );
        end
        grid on, axis tight;
        if indHyp == 1, ylabel( 'final hyperparameter estimates' ), end;
    end
         
else
    
    % Multiple indices  
    
    bBuildArray = 0; % Default
    if ~exist( 'sPerfResArray', 'var' )
        disp( 'Constructing sPerfResArray...' );
        bBuildArray = 1;
    else
        disp( 'Reusing sPerfResArray' );
    end
    
    figure( figInd ), clf;
    
    for i = 1:length( resfileInd )              
        szResfile = char( resfile( resfileInd(i) ) );
        szReconFieldname = char( reconfield( resfileInd(i) ) );
       
        if bBuildArray
            sPerfResArray(i) = irecon_collect( 'resfile', szResfile, ...
                'snrdir', snrdir, ...
                'snrreal', snrreal( resfileInd(i), : ), ...
                'spriv', struct( 'szReconFieldname', szReconFieldname ), ...
                'fcncull', 'irecon_perf_cull' );
        end
        
        %disp( sprintf( 'i=%g', i ) );
        m = sPerfResArray(i).mean( :, errind );
        s = sPerfResArray(i).std( :, errind );
        
        %figure( i ), clf;
        if ( i == 1 ), hold on, end;
        errorbar( vecSnrDbSorted, m(sortedInd), s(sortedInd), char( sszPlotColour(i) ), ...
            'LineWidth', 3, 'MarkerSize', 10 );
        %ylabel( char( sszMetricName(errind) ), 'Interpreter', 'none' );
        xlabel( 'SNR [dB]' );
        %title( sprintf( 'resfile = %s', szResfile ), 'Interpreter', 'none' );
        %disp( 'Pausing...' ), pause;
    end
           
end

%plot( vecSnrDbSorted, 9./(10.^(vecSnrDbSorted/20)), 'b--' );
%axis tight, grid on;
