
% Jan 28, 2007. It's pretty silly to create a separate file just for the
% TIP draft, but this makes things clearer.
%///////////////////////////////////////////////////////////////////////

resfileInd = [ 9, 8, 1, 10, 11 ];
% resfileInd = [ 8 ];
    
% See irecon_perf_cull and sp_img_error for the meaning of these indices
errIndVec = [ 1, 3, 6, 2, 7 ];

figVec = 1:length(errIndVec);

if length( resfileInd ) == 1
    figVec = [ figVec, figVec(end) + 1 ];
end

% NB. the map_revised version are all using map2
% map_revised: G_SPECIAL = 1/sqrt(2)
% map_revised2: 1e-4
% map_revised3: 0
% map_revised4: 1e4
% map_revised5: 1e3

resfile = { 'map_revised.mat', 'eb_better_nov05.mat', 'lars_v1.mat', ...
    'map_revised2.mat', 'map_revised3.mat', 'map_revised4.mat', ...
    'map_revised5.mat', 'map1.mat', 'landweb.mat', ...
    'lars_v2.mat', 'lars_strat3_mar.mat', 'sbl2.mat', ...
    'landwebpos.mat' };

reconfield = { 'last', 'last', 'last', ...
    'last', 'last', 'last', ...
    'last', 'last', 'last', ...
    'last', 'bestBeta3', 'last', ...
    'last' };

% snrdir = [ 2, 3, 4, 5, 6, 7, 8, 9, 10, 11 ];
% vecSnrDb = [ 1.76, 3.01, 3.98, 4.77, 5, 7, 10, 13, 20, 16 ];
% snrreal = [ 100, 30, 30, 30, 30, 30, 30, 70, 50, 30; ...
%             30, 30, 30, 30, 30, 30, 30, 70, 50, 30; ...
%             30, 30, 30, 30, 30, 30, 30, 30, 50, 30; ...
%             50, 30, 30, 30, 30, 30, 30, 30, 30, 30; ...
%             50, 30, 30, 30, 30, 30, 30, 30, 30, 30; ...
%             30, 30, 30, 30, 30, 30, 30, 30, 30, 30; ...
%             30, 30, 30, 30, 30, 30, 30, 30, 30, 30; ...
%             30, 30, 30, 30, 30, 30, 30, 30, 30, 30; ...
%             30, 30, 30, 30, 30, 30, 30, 30, 30, 30; ...
%             30, 30, 30, 30, 30, 30, 30, 30, 30, 30; ...
%             30, 30, 30, 30, 30, 30, 30, 30, 30, 30 ];


% Do not look at snr6
snrdir = [ 2, 3, 4, 5, 7, 8, 9, 10, 11 ];
vecSnrDb = [ 1.76, 3.01, 3.98, 4.77, 7, 10, 13, 20, 16 ];

% Build the args to perf_collect and perf_plot
%/////////////////////////////////////////////

caszResfile = cell( 1, length( resfileInd ) );
caszReconFieldname = cell( size( caszResfile ) );

for i = 1:length( resfileInd )
    caszResfile{i} = resfile{ resfileInd(i) };
    caszReconFieldname{i} = reconfield{ resfileInd(i) };
end

caszDirname = cell( 1, length(snrdir ) );
for dirInd = 1:length( snrdir )
    caszDirname{ dirInd } = sprintf( 'snr%g', snrdir( dirInd ) );
end

sFilecount = get_file_count( 'dir_names', caszDirname, 'file_names', caszResfile );
snrreal = sFilecount.filecount;

if ~exist( 'sPerfRes', 'var' ) | ~exist( 'sHypRes', 'var' )

    [sPerfRes, sHypRes] = perf_collect( 'ssz_resfile', caszResfile, 'ssz_recon_fieldname', caszReconFieldname, ...
        'snr_dir', snrdir, 'snr_dir_nreal', snrreal, 'err_ind_vec', errIndVec );

end

perf_plot( 'snr_db', vecSnrDb, 'fig_vec', figVec, 'err_ind_vec', errIndVec, ...
    's_perf_res', sPerfRes, 's_hyp_res', sHypRes, 'b_logy', 0, ...
    'ssz_tag', { 'Landweber', 'MAP1', 'MAP2', 'LASSO-SURE', 'H-SURE' } );
