
% Copied from binary_s1 and modified as needed. For the case where we draw
% the image from the J&S prior.

% Upgrade this so that it parallels tip_binary_s1 in that we use
% perf_collect and perf_plot.

resfileInd = [ 5 3 4 10 ];

errIndVec = [ 2 ];

figVec = 1:3;

% map_revised: G_SPECIAL = 1/sqrt(2)
% map_revised2: 1e-4
% map_revised3: 0
% map_revised4: 1e4
% map_revised5: 1e3
% map1_fixed: MAP1 with fixed (a,w)
% map2_fixed: MAP2 with G_SPECIAL=0, and fixed (a,w)

resfile = { 'lars_v1.mat', 'map_revised3.mat', 'map_revised.mat', ...
            'map_revised5.mat', 'map1.mat', 'eb_better_nov05.mat', ...
            'eb_fixed.mat', 'map1_fixed.mat', 'map2_fixed.mat', ...
            'lars_v2.mat', 'lars_strat3_mar.mat' };

reconfield = {  'last', 'last', 'last', ...
                'last', 'last', 'last', ...
                'last', 'last', 'last', ...
                'last', 'bestBeta3' };

snrdir = [ 2, 3, 4, 5, 7, 8, 9, 10, 11 ];
vecSnrDb = [ 1.76, 3.01, 3.98, 4.77, 7, 10, 13, 20, 16 ];

[vecSnrDbSorted, sortedInd] = sort( vecSnrDb );


% Build the args to perf_collect and perf_plot. Copied from tip_binary_s1.
%/////////////////////////////////////////////////////////////////////////

caszResfile = cell( 1, length( resfileInd ) );
caszReconFieldname = cell( size( caszResfile ) );

for i = 1:length( resfileInd )
    caszResfile{i} = resfile{ resfileInd(i) };
    caszReconFieldname{i} = reconfield{ resfileInd(i) };
end

caszDirname = cell( 1, length(snrdir ) );
for dirInd = 1:length( snrdir )
    caszDirname{ dirInd } = sprintf( 'snr%g', snrdir( dirInd ) );
end

sFilecount = get_file_count( 'dir_names', caszDirname, 'file_names', caszResfile );
snrreal = sFilecount.filecount;

if ~exist( 'sPerfRes', 'var' ) | ~exist( 'sHypRes', 'var' )

    [sPerfRes, sHypRes] = perf_collect( 'ssz_resfile', caszResfile, 'ssz_recon_fieldname', caszReconFieldname, ...
        'snr_dir', snrdir, 'snr_dir_nreal', snrreal, 'err_ind_vec', errIndVec );

end

perf_plot( 'snr_db', vecSnrDb, 'fig_vec', figVec(1), 'err_ind_vec', errIndVec, ...
    's_perf_res', sPerfRes, 's_hyp_res', sHypRes, 'b_logy', 0, ...
    'ssz_tag', { 'MAP1', 'MAP2, g^\ast=2^{-1/2}', 'MAP2, g^\ast=10^3', 'LASSO-SURE' }  );


% Handle the hyperparameter plots separately. We want to plot \hat{a} and
% \hat{w} for MAP1 and the two MAP2 methods
%/////////////////////////////////////////////////////////////////////////

figure( figVec(2) ), clf
semilogy( vecSnrDbSorted, sHypRes(1).mean( sortedInd, 1 ), 'rs-', 'LineWidth', 2 ), hold on
semilogy( vecSnrDbSorted, sHypRes(2).mean( sortedInd, 1 ), 'g--', 'LineWidth', 2 )
semilogy( vecSnrDbSorted, sHypRes(3).mean( sortedInd, 1 ), 'bx-', 'LineWidth', 2 )
xlabel( 'SNR [dB]' ), axis tight

figure( figVec(3) ), clf
plot( vecSnrDbSorted, sHypRes(1).mean( sortedInd, 2 ), 'rs-', 'LineWidth', 2 ), hold on
plot( vecSnrDbSorted, sHypRes(2).mean( sortedInd, 2 ), 'g--', 'LineWidth', 2 )
plot( vecSnrDbSorted, sHypRes(3).mean( sortedInd, 2 ), 'bx-', 'LineWidth', 2 )
xlabel( 'SNR [dB]' ), axis tight
