
% Function to compute M(D) of Gribonval & Nielsen paper

% if-else-end structure copied from recon_htest

if ~isvar( 'xtrue' )
    % Generate our data
    f = rand( 64, 64 ) > 0.995;
    h = fspecial( 'gaussian', size(f), 0.3 );
    fClean = f;
    %fh = imfilter( f, h );
    fh = real( ifftn( fftn(h) .* fftn(fClean) ) );
    sigma = 0.1;
    fhNoisy = fh + randn( size(fh) ) * sigma;
else
    % Re-use existing data
    fClean = xtrue;
    %h = zeros( size( fClean ) );
    %h( 1:size(psf,1), 1:size(psf,2) ) = psf;
    %fh = real( ifftn( fftn(h) .* fftn(fClean) ) );
    fh = y0;
    sigma = estd;
    %fhNoisy = fh + randn( size(fh) ) * sigma;
    fhNoisy = yi;

    if 1 % Sanity
        disp( 'SANITY: figuring out h' );
        psfSize = max( size( psf ) );
        bPsfMatch = 0;
        for i = 1:( size(fClean,2) - size(psf,2) + 1 )
            h = zeros( size( fClean ) );
            h( i:(i+size(psf,1)-1), i:(i+size(psf,2)-1) ) = psf;
            fhTest = real( ifftn( fftn(h) .* fftn(fClean) ) );
            normDiff = norm( fh - fhTest, 2 )
            if ( abs( normDiff ) < eps )
                disp( 'Matched psf, i:' ), disp( i ), bPsfMatch = 1;
                break;
            end
        end
    end

    if 0
        figure( 1 ), imagesc( fClean );
        figure( 2 ), imagesc( fhTest );
        figure( 3 ), imagesc( fh );
        figure( 4 ), imagesc( fhNoisy );
        disp( 'Pausing...press key to continue' ), pause;
        close all;
    end

    if ( bPsfMatch == 0 ), error( 'No match for psf!' ), end;

    % XXX: Debug
    %return;
end

% At this point, we should have h[*,*] in matrix form. Now go through
% and compute M(D)

tic
MD = mex_compute_md( h, -1 );
tElapsed = toc
