% Creates a checkboard of randomly placed zeros and ones
%
% c = create_checker( imgSize, fracOnes, nonZeroVal )
%

function c = create_checker( imgSize, fracOnes, nonZeroVal )
c = zeros( prod(imgSize), 1 );
n = length(c);
z = randperm( n );
numOnes = floor( n * fracOnes );
c( z(1:numOnes) ) = nonZeroVal;
c = reshape( c, imgSize );
