% estep: the E-step in the E-M algorithm
%-------------------------------------------------------------------------------
% zHat_t = estep( fftSize, hty, HpH, r, thetaHat_t )
%
function zHat_t = estep( fftSize, hty, HpH, r, thetaHat_t )

% This is the straight-form eqn, which should not be implemented, due to the
% size of H
%zHat_t = thetaHat_t + (alpha/sigma)^2 * H' * ( y - H*thetaHat_t );

% This relies on using the DFT. Note that we make use of several pre-computed
% variables, which must be supplied.
ThetaHat_t = fftn( thetaHat_t, fftSize ); 
tmp = hty - real( ifftn( HpH .* ThetaHat_t, fftSize ) );
zHat_t = thetaHat_t + r^2 * tmp;

% DEBUG
disp( '=== estep [DEBUG] ===' );
disp( '||tmp||' ), norm( tmp, 1 )
disp( '||thetaHat_t||' ), norm( thetaHat_t, 1 )
 
