% Density of observations assuming laplacian prior and gaussian noise
%
% p = fLaplacianGauss( y, a, w, sigma )
%

function p = fLaplacianGauss( y, a, w, sigma )
p = (1-w) * normpdf( y, 0, sigma ) + a*w/4 * exp( (a*sigma)^2/2 ) * ...
	( exp(  a*y ).*( 1 - erf( (y/sigma + a*sigma)/sqrt(2) ) ) + ...
	  exp( -a*y ).*( 1 + erf( (y/sigma - a*sigma)/sqrt(2) ) ) );

