% gen_exp_data: Generates data from a one-sided exponential density.
% Modified from gen_john_data.
%
% Usage:
%    fClean = gen_exp_data( n, lambda, w )
%
function fClean = gen_exp_data( n, lambda, w ) 

tmp = zeros( n, 1 );

for i = 1:floor(n*w)
	% Non-zero
	tmp(i) = exp_transform( rand, lambda );
end

fClean = tmp( randperm(n) );

function x = exp_transform( y, lambda )
if ( ( y >= 0 ) & ( y < 1 ) )
	x = - log( 1 - y ) / lambda;
else
	error( 'illegal value of y' );
end

