% h_deconv_chk: checks out some properties of the inverse filter in deconv
%-------------------------------------------------------------------------------

par = psf_param3( 1, 3e4, 10 );
stMesh = psf_mesh( par );

psf_mesh_chk( stMesh );
h = get_h_op( par, stMesh, 1 );
H = fftn( h );
HSize = size( H );
if ( HSize(1) ~= HSize(2) ), error( 'H is not a square matrix?' ), end;
HInvH = zeros( size( H ) ); % operator HInvH = (HInv o H)

numHinvZeroed = 0;
NORM_THRES = 1e-6;

for k = 1:HSize(1)
	for l = 1:HSize(2)
		if ( abs( H(k,l) ) <= NORM_THRES )
			numHinvZeroed = numHinvZeroed + 1;
		else
			% |H[k,l]| > NORM_THRES
			HInvH = 1;
		end
	end
end

disp( sprintf( 'numHinvZeroed = %g/%g', numHinvZeroed, HSize(1)*HSize(2) ) );

matHInvH = ifftn( HInvH );
matErr = matHInvH - diag( ones( HSize(1) ) ); 
vecErrNorm = [ norm(matErr,1), norm(matErr,2), norm(matErr,inf) ]

