
% img_correct_cc: Correct for circular shift effect that occurs when
% implementing a convolution via DFTs

function imgCorrect = img_correct_cc( szPsfType, propPsf, imgOrig )

switch ( szPsfType )
	case 'gaussian'
		vecShiftGauss = [ -propPsf.nk_half, -propPsf.nk_half ];
		imgCorrect = circshift( imgOrig, vecShiftGauss );
            
	case 'mrfm'
		%vecShiftMrfm = round( [ -psfNnzInterX(2)/2, -psfNnzInterY(2)/2 ] );
		vecShiftMrfm = round( [ -propPsf{3}(1,2)/2, -propPsf{3}(2,2)/2 ] );
		imgCorrect = circshift( imgOrig, vecShiftMrfm );
            
	otherwise
		error( 'unrecognized szPsfType' );
end
