% lap_pos_med: plot the posterior median assuming gamma = laplace
%-------------------------------------------------------------------------------
function lap_pos_med( a, w )

x = linspace( -5, 5, 100 );

v = f( x, a, w );
%figure( 1 ), plot( x, v, 'r-' ), title( 'density f(x;a,w)' ), xlabel( 'x' );
%figure( 2 ), plot( x, normcdf(x), 'b-' ), title( 'normcdf(x)' ), xlabel( 'x' );

foo = zeros( size(x) );
moo = zeros( size(x) );
s = linspace( -5, 5, 100 );
xx = -5;

if 0 % XXX: plot the posterior cdf for a value of x=xx
for i = 1:length(s)
	if ( s(i) < 0 )
		foo(i) = 1/f( xx,a,w ) * w*a/2 * exp(a*(xx+a/2)) * ...
			normcdf( s(i) - xx - a );
	end
	if ( s(i) > 0 )
		foo(i) = 1/f( xx,a,w ) * ( ...
			w*a/2*exp( a^2/2 )*(exp(a*xx)*normcdf(-(xx+a)) - ...
							   	exp(-a*xx)*normcdf(-(xx-a))) + ...
			(1-w)*normpdf( xx,0,1 ) + w*a/2*exp(-a*(xx-a/2)) * ...
			normcdf( s(i) - xx + a ) );
	end
end
figure( 3 ), plot( s, foo, 'k--' );
end

postmed = zeros( size(x) );

if 1 % XXX: plot the threshold function of the posterior median
for i = 1:length(x)
	tmp = 1/(a*w)*exp(-a*(x(i)+a/2))*f( x(i), a, w );
	s1 = x(i) + a + norminv( tmp );
	if ( s1 < 0 ), postmed(i) = s1; continue, end
	%postmed(i) = s1;

	tmp = 1/(a*w)*exp(a*(x(i)-a/2))*( f( x(i), a, w ) - ...
									  2*(1-w)*normpdf( x(i), 0, 1 ) ) - ...
		exp(a*x(i))*( exp(a*x(i))*normcdf(-x(i)-a) - ...
					  exp(-a*x(i))*normcdf(-x(i)+a) );
	s2 = x(i) - a + norminv( tmp );
	if ( s2 > 0 ), postmed(i) = s2; continue, end
	%postmed(i) = s2;

	%postmed(i) = 0;
end
figure( 4 ), plot( x, postmed, 'r-', x, x, 'k:' );
end

global aa ww
aa = a;
ww = w;

if 1 % XXX: find the threshold given values of w, a
	thres = fzero( @thresCurveFcn, x(1) );
	disp( sprintf( 'thres = %g', abs(thres) ) );
end

function v = f( x, a, w )
v = (1-w) * normpdf( x, 0, 1 ) + a*w/4* exp( a^2/2 ) * ...
	( exp( a*x ).*(1 - erf( (x+a)/sqrt(2) )) + ...
	  exp( -a*x ).*(1 + erf( (x-a)/sqrt(2) )) );

function v = thresCurveFcn( x )
global aa ww
v = 1/f( x, aa, ww ) * ww*aa/2 * exp(aa*(x+aa/2)) * normcdf(-x-aa) - 1/2;
