%....................................................
function logp = logp_hyper_john_unif( theta, aRange )
%####################################################

logp = 0;
theta = theta(:);
n = length( theta );

a1 = aRange(1);
a2 = aRange(2);
aDiff = a2 - a1;
if ( aDiff < 0 )
    error( 'logp_hyper_john_unif: unexpected aRange' );
end

for i = 1:n
	absTheta_i = abs( theta(i) );
    if ( absTheta_i < 1e3*eps ), logp = logp + log( 0.5 );
    else
        tmp = exp( -a1*absTheta_i )*( a1*absTheta_i + 1 ) - ...
            exp( -a2*absTheta_i )*( a2*absTheta_i + 1 );
        logp = logp + log( tmp / ( 4*absTheta_i^2*aDiff ) );
    end
end


