%.......................................................
function logp = logp_hyper_laplace_unif( theta, aRange )
%#######################################################

logp = 0;
theta = theta(:);
n = length( theta );

a1 = aRange(1);
a2 = aRange(2);
aDiff = a2 - a1;
if ( aDiff < 0 )
    error( 'logp_hyper_laplace_unif: unexpected aRange' );
end

inc0 = log( (a1 + a2)/4 );

for i = 1:n
	absTheta_i = abs( theta(i) );
	if ( absTheta_i < 1e3*eps ), logp = logp + inc0;
	else
		tmp = exp( -a1*absTheta_i )*( a1*absTheta_i + 1 ) - ...
			exp( -a2*absTheta_i )*( a2*absTheta_i + 1 );
		logp = logp + log( tmp / ( 2*absTheta_i^2*aDiff ) );
	end
end


