function [a_hat,t_hat,w_hat,mu_hat,aRange,tRange]=map_2d_ver4(y,sig);
%%% y - data vector
sdev=std(y);
N=length(y);
%% initial grid
a_vec=linspace(1e-6, 3,64)'/sdev;
aRange = [1e-6,3];
da=a_vec(2)-a_vec(1);
t_vec=linspace(1e-6,4,64)'*sdev;
tRange = [1e-6,4];
dt=t_vec(2)-t_vec(1);
%%% 
RR=2; %%% Number of grid refinement steps
rr=0;
while (rr<RR)
      rr=rr+1;
      lt=length(t_vec);
      la=length(a_vec);
      mean_t0=zeros(lt,1);
      mean_t1=zeros(lt,1);
      mean_t2=zeros(lt,1);
      dmap=zeros(la,1);
      %%% Compute 'sufficient stats' : \hat{T}_k(t) k=0,1,2
      for l=1:lt;    
              t=t_vec(l);
              mean_t0(l)=mean(abs(y)>t);
              mean_t1(l)=mean(abs(y).*(abs(y)>t));
              mean_t2(l)=mean(abs(y).^2.*(abs(y)>t)) ;
      end
      for k=1:la;
          a=a_vec(k);           
          t=t_vec;
 %         t=t_vec+a_vec(k)*sig^2;
          w=1./(1+exp((t-a*sig^2).^2/2/sig^2));
          e_t0=erfc(t/sqrt(2)./sig)+w/2*exp(a.^2*sig.^2/2).*(exp(-a*t).*...
                  erfc((a*sig.^2-t)/sqrt(2)./sig)-...
                  exp(a*t).*erfc((a*sig.^2+t)/sqrt(2)./sig));
          e_t1=sqrt(2/pi)*sig.*exp(-t.^2/2./sig.^2)+w/2./a.*exp(a.^2*sig.^2/2).*...
                  ((1-a*t).*exp(a*t).*...
                  erfc((a*sig.^2+t)/sqrt(2)./sig) + (1+a*t).*exp(-a*t).*...
                  erfc((a*sig.^2-t)/sqrt(2)./sig));
          e_t2=sig.^2.*(sqrt(2/pi)*t./sig.*exp(-t.^2./sig.^2/2)+erfc(t/sqrt(2)./sig))+...
                  2*w./a^2.*erfc(t/sqrt(2)./sig)+w/2/a^2.*exp(a^2*sig.^2/2).*(...
                  ((a*t).^2+2*(a*t)+2).*exp(-a*t).*erfc((a*sig.^2-t)/sqrt(2)./sig)-...
                  ((a*t).^2-2*(a*t)+2).*exp(a*t).*erfc((a*sig.^2+t)/sqrt(2)./sig));
          e_dt0=-1/pi^(1/2).*exp(-1/2.*t.^2/sig^2).*2^(1/2)/sig+1/2.*w.*exp(1/2.*a^2.*sig^2).*(-a.*exp(-a.*t).*erfc(1/2.*(a.*sig^2-t).*2^(1/2)/sig)+exp(-a.*t)/pi^(1/2).*exp(-1/2.*(a.*sig^2-t).^2/sig.^2).*2^(1/2)/sig-a.*exp(a.*t).*erfc(1/2.*(a.*sig^2+t).*2^(1/2)/sig)+exp(a.*t)/pi^(1/2).*exp(-1/2.*(a.*sig^2+t).^2/sig^2).*2^(1/2)/sig);
          e_dt1=-2^(1/2).*(1/pi)^(1/2)/sig.*t.*exp(-1/2.*t.^2/sig^2)+1/2.*w/a.*exp(1/2.*a^2.*sig^2).*(-a.*exp(a.*t).*erfc(1/2.*(a.*sig^2+t).*2^(1/2)/sig)+(1-a.*t).*a.*exp(a.*t).*erfc(1/2.*(a.*sig^2+t).*2^(1/2)/sig)-(1-a.*t).*exp(a.*t)/pi^(1/2).*exp(-1/2.*(a.*sig^2+t).^2/sig^2).*2^(1/2)/sig+a.*exp(-a.*t).*erfc(1/2.*(a.*sig^2-t).*2^(1/2)/sig)-(1+a.*t).*a.*exp(-a.*t).*erfc(1/2.*(a.*sig^2-t).*2^(1/2)/sig)+(1+a.*t).*exp(-a.*t)/pi^(1/2).*exp(-1/2.*(a.*sig^2-t).^2/sig^2).*2^(1/2)/sig);
          e_dt2=sig^2.*(2^(1/2).*(1/pi)^(1/2)/sig.*exp(-1/2.*t.^2/sig^2)-2^(1/2).*(1/pi)^(1/2)/sig^3.*t.^2.*exp(-1/2.*t.^2/sig^2)-1/pi^(1/2).*exp(-1/2.*t.^2/sig^2).*2^(1/2)/sig)-2.*w/a^2/pi^(1/2).*exp(-1/2.*t.^2/sig^2).*2^(1/2)/sig+1/2.*w/a^2.*exp(1/2.*a^2.*sig^2).*((2.*a^2.*t+2.*a).*exp(-a.*t).*erfc(1/2.*(a.*sig^2-t).*2^(1/2)/sig)-(a^2.*t.^2+2.*a.*t+2).*a.*exp(-a.*t).*erfc(1/2.*(a.*sig^2-t).*2^(1/2)/sig)+(a^2.*t.^2+2.*a.*t+2).*exp(-a.*t)/pi^(1/2).*exp(-1/2.*(a.*sig^2-t).^2/sig^2).*2^(1/2)/sig-(2.*a^2.*t-2.*a).*exp(a.*t).*erfc(1/2.*(a.*sig^2+t).*2^(1/2)/sig)-(a^2.*t.^2-2.*a.*t+2).*a.*exp(a.*t).*erfc(1/2.*(a.*sig^2+t).*2^(1/2)/sig)+(a^2.*t.^2-2.*a.*t+2).*exp(a.*t)/pi^(1/2).*exp(-1/2.*(a.*sig^2+t).^2/sig^2).*2^(1/2)/sig);
          e_p=sig^2+2.*w/a^2;
          %%% d dt
          Ft=(a*t-t.^2/2/sig^2).*e_dt0+(a-t/sig^2).*e_t0+e_dt2/2/sig^2-a*e_dt1;
          ft=cumsum(Ft); 
          %%% map(t) for fixed a and sig
          map=(a*t_vec -t_vec.^2/2/sig^2).*mean_t0+mean_t2/2/sig^2 - ...
                  a*mean_t1-ft*dt; %%% ft*dt = int F(t) dt
          ix=find(t_vec>=a*sig^2);
          tmp_t=t_vec(ix);
          tmp_map=map(ix);
          [val,idx]=max(tmp_map);
          if length(idx)==0
             disp('no grid')
             t_opt(k)=a*sig^2;
             tmptmp(k)=1;
             dmap(k)=-1e10;
          elseif length(idx)>1
             disp('more than one maxs')
          else
            t_opt(k)=tmp_t(idx);  %%% optimal t : \hat{t}(a,sig)
%%%         tmptmp(k)=(tmp_t(idx)==tmp_t(1))|(tmp_t(idx)==tmp_t(end)); %%% boundry test
            tmptmp(k)=(tmp_t(idx)==tmp_t(end)); %%% boundry test      
            tmptmp(k)=0;
           %%%%%%% (d map(a,t,sig) / d a) evaluated at t=\hat{t}(a,sig) 
          dmap(k)=t_opt(k)*(mean_t0(ix(idx))-e_t0(ix(idx)))-(mean_t1(ix(idx))-e_t1(ix(idx)));
     %%% Debug plot
%           plot(tmp_t,tmp_map,t_opt(k),val,'x')
%           xlabel('t')
%           ylabel('map(t;a)')    
%           pause   
        end
      
     end   
     [val,idx]=min(0.5 * abs(dmap)/norm(dmap) +[1; sign(dmap(1:end-1).*dmap(2:end))]);
     %%% Debug plot
%       plot(a_vec,dmap,a_vec(idx),dmap(idx),'x')
%       xlabel('a')
%       pause
     
     %% optimal t and a
     t_hat=t_opt(idx);
     a_hat=a_vec(idx);    
     fl_t=tmptmp(idx); %%% boundry test for optimal t

     t_vec=linspace(max(1e-6*sdev,t_hat-3*dt),max(t_hat+3*dt,sqrt( 2*log(N) )*sdev*sig),64)';
     tRange=[max(1e-6*sdev,t_hat-3*dt),max(t_hat+3*dt,sqrt( 2*log(N) )*sdev*sig)];
     dt=t_vec(2)-t_vec(1);
     a_vec=linspace(max(a_hat-3*da,1e-6/sdev),a_hat+3*da,64)';
     aRange=[max(a_hat-3*da,1e-6/sdev),a_hat+3*da];
     da=a_vec(2)-a_vec(1);


          
end %%% end while
rr;
w_hat=1./(1+exp((t_hat-a_hat*sig^2).^2/2/sig^2));
mu_hat=(y-sign(y)*a_hat*sig^2).*(abs(y)>t_hat);
