% plot_log_lik: plots the log likelihood for the EB method
%-------------------------------------------------------------------------------
% Uses eb_log_lik.
%
% Usage:
%    m = plot_log_lik( wRange, aRange, vecX )
%
function m = plot_log_lik( wRange, aRange, vecX )

global y paramSdev

numWPts = 30;
numAPts = 30;

vecW = linspace( wRange(1), wRange(2), numWPts );
vecA = linspace( aRange(1), aRange(2), numAPts );

y = vecX(:);
paramSdev = 2.79512e-3;

m = zeros( numWPts, numAPts );

warning off;

for indW = 1:numWPts
	for indA = 1:numAPts
		%m( indW, indA ) = eb_log_lik( vecW(indW), vecA(indA), vecX );
		%m( indW, indA ) = neg_laplace_log_lik_map_awsigma( ...
		%	[vecA(indA),vecW(indW),paramSdev] );
		%m( indW, indA ) = neg_laplace_log_lik_at( [vecA(indA),vecW(indW)] );
		m( indW, indA ) = neg_laplace_log_lik_atsigma( ...
			[vecA(indA),vecW(indW),paramSdev] );
	end
end

warning on;

figure, surfc( vecA, vecW, m );
xlabel( 'a' ), ylabel( 'w' );
figure, contour( vecA, vecW, m );
xlabel( 'a' ), ylabel( 'w' );
%title( 'Plot of log likelihood' );


