% plot_ss_models: Matlab file to plot stupid sample waveforms from different
% single spin-cantilever models

load sample_ss_models

figure( 1 ), plot( ctc_sig(50:550, 3), 'b', 'LineWidth', 4 );
set( gca, 'XTick', [], 'YTick', [] );
axis off;

figure( 2 ), subplot( 211 ), [xx, yy] = stairs( dtrt_sym(100:250) );
plot( xx, yy, 'r', 'LineWidth', 4 );
set( gca, 'XTick', [], 'YTick', [] );
%ylabel( '(a)     ', 'Rotation', 0 );
axis off;

figure( 2 ), subplot( 212 ), [xx, yy] = stairs( dtrt_asym(1:150) );
plot( xx, yy, 'r', 'LineWidth', 4 );
set( gca, 'XTick', [], 'YTick', [] );
%ylabel( '(b)     ', 'Rotation', 0 );
axis off;

figure( 3 ), plot( rwalk(1:80), 'm', 'LineWidth', 4 );
set( gca, 'XTick', [], 'YTick', [] );
axis off;

print -f1 -djpeg ctc_sample.jpg
print -f2 -djpeg dtrt_sample.jpg
print -f3 -djpeg dtrw_sample.jpg
