
% plot_thres
% - Plots several thresholding functions for Dan's presentation
% - Adapted to plot thresholds for IMA 2005 poster

a=0.3;
w=0.1;
sdev=1;
lambda = a/sqrt(2);

y = linspace( -5, 5, 100 );
tMed = convert_wsigma2t( a, w, sdev, 'median' );

figure( 1 ), clf


%plot( y, laplace_map_thres0( y, a, w, sdev ), 'r', 'LineWidth', 1.5 );
%plot( y, laplace_map_thres0( y, a, w, sdev ), 'k', 'LineWidth', 1.5 );

hold on; % After the first plot

plot( y, laplace_posterior_med( y, a, tMed, sdev ), 'g', 'LineWidth', 3 );
%plot( y, laplace_posterior_med( y, a, tMed, sdev ), 'k-.', 'LineWidth', 1.5 );

%plot( y, laplace_posterior_med( y, a, 1, sdev*2, 'w' ), 'b', 'LineWidth', 1.5 );
%plot( y, soft_thres( y, tMed ), 'k', 'LineWidth', 1.5 );
%plot( y, exp_thres( y, lambda, sdev ), 'm', 'LineWidth', 1.5 );

%legend( 'a: Landweber', 'b: EM-MAP', 'c: EM-EB', 0 );
%legend( 'T_{MAP-LA}', 'T_{EBD-LA}', 'T_{EBD-L}', 'T_{F-L}', 'T_{EBD-E(1|2)}', 0 );
%legend( 'T_{EM-LA}', 'T_{EBD-LA}', 'T_{L1}', 'T_{EBD-E1}', 0 );

plot( y, y, 'k:', 'LineWidth', 3 );
plot( [y(1),y(end)], [0,0], 'k:', 'LineWidth', 3 );

% Set font size
setaxs = 'set(get(gca,';
fontsty = '''Fontsize'', 14);';
szCmd = [setaxs, '''xlabel''),', fontsty]
eval( szCmd );
eval( [setaxs, '''ylabel''),', fontsty] );
leg = legend;
eval( ['set(leg,', fontsty] );
