% plot_thres_surf: Plots the threshold as a function of (a,w)

aGrid = struct( 'min', 1e-6, 'max', 100, 'npts', 1e2 );
aGrid.vec = linspace( aGrid.min, aGrid.max, aGrid.npts );

wGrid = struct( 'min', 1e-6, 'max', 1, 'npts', 1e2 );
wGrid.vec = linspace( wGrid.min, wGrid.max, wGrid.npts );

sigmaFixed = 1e-2;

t = zeros( aGrid.npts, wGrid.npts );

for i = 1:wGrid.npts
	for j = 1:aGrid.npts
		t( i, j ) = convert_wsigma2t( aGrid.vec(j), wGrid.vec(i), sigmaFixed, 'median' );
	end
end

numFig = 1;
figure( numFig ), contour( aGrid.vec, wGrid.vec, t );
%figure( numFig ), surfc( aVec, tVec, x );
