
% soft_thres: Implements the soft thresholding rule

function est = soft_thres( y, t )

if ( t < 0 ), error( 'soft_thres: t < 0' ), end;

pos = ( y >= t ) .* ( y - t );
neg = ( y <= -t ) .* ( y + t );
est = pos + neg;

if 0 % DEBUG
    figure( 1 ), plot( y, 'bx' );
    figure( 2 ), plot( est, 'ro' );
    pause;
end

