
% Normalize psf and consequently, the noiseless and noisy observations

sRes = emsep_comp_alpha( fftn(h), [], propNoise.sigma );
disp( 'sRes before:' ), disp( sRes );

normalizeFac = sqrt( sRes.lambdaNnzMax );
psf = psf / normalizeFac;
h( iMatch:(iMatch+size(psf,1)-1), iMatch:(iMatch+size(psf,2)-1) ) = psf;

G = Gblur( mask, 'psf', psf, 'type', 'conv,fft' );
y0 = G * xtrue;

if strcmp( SZ_PSF_TYPE, 'gaussian' )         
	% Tuned for Gaussian blur
	switch ( SZ_IMAGE_TYPE )
		case 'uniform'
			propNoise = struct( 'sigma', 1e-2 );
		case 'exp'
			propNoise = struct( 'sigma', .05 * max(y0(:)) );
			%                 propNoise = struct( 'sigma', 1e-2 );
		case 'uniform2'
			propNoise = struct( 'sigma', 0.16 );
		case 'js_prior'
			%propNoise = struct( 'sigma', 1e-2 );
			%propNoise = struct( 'sigma', 0.1 );
			%propNoise = struct( 'sigma', 2 );
			propNoise = struct( 'sigma', .05 * max(y0(:)) );
		otherwise
			error( 'propNoise.sigma = ???' );
	end        
else
	% Tuned for MRFM blur
	propNoise = struct( 'sigma', 5e-2*max(y0(:)) );
end
 
randn( 'state', 0 ); % Reset state so we get the same "random" noise
yi = y0 + propNoise.sigma * randn(size(y0));

% Have to do a circular shift to correctly display y0 and yi. Due to
% the way that we implement convolution.

y0Display = img_correct_cc( SZ_PSF_TYPE, propPsf, y0 ); 
yiDisplay = img_correct_cc( SZ_PSF_TYPE, propPsf, yi );

figure(2);
pl2 = 120;
im( pl2+1, y0Display, 'y0' ), colorbar
im( pl2+2, yiDisplay, 'yi' ), colorbar


sResAfter = emsep_comp_alpha( fftn(h), [], propNoise.sigma );
disp( 'sRes after:' ), disp( sResAfter );
