
function vecAbsColSum = spec_compute_k( hForwardOp, imgNoisy, noiseSigma )

n = length( imgNoisy(:) );
  
hForwardOpDft = fftn( hForwardOp );
HEigMax = max( abs( hForwardOpDft(:) ) );
HEigMin = min( abs( hForwardOpDft(:) ) );
disp( sprintf( 'H max eig: %g, min eig: %g, cond no: %g', HEigMax, HEigMin, ...
	HEigMax / HEigMin ) );

gamH_gam = conj( hForwardOpDft ) .* hForwardOpDft;
gam_gamH = hForwardOpDft .* conj( hForwardOpDft );

lambdaMax = max( gam_gamH(:) );
alphaUpperBound = noiseSigma / sqrt( lambdaMax );

disp( sprintf( 'lambdaMax: %g, noiseSigma: %g, alphaUpperBound: %g', ...
	lambdaMax, noiseSigma, alphaUpperBound ) );

alpha = alphaUpperBound;
sRestoreOptions.alpha = alpha;

vecAbsColSum = [];
r = alphaUpperBound / noiseSigma;

for indJ = 1:n
    val = get_abs_col_sum( hForwardOpDft(:), r, indJ, n );
    disp( sprintf( 'indJ: %g, computed %g', indJ, val ) );
    vecAbsColSum(indJ) = val;
    pause( 1 );
end

%.........................................................
function absColSum = get_abs_col_sum( vecLambda, r, j, n )
%#########################################################

veckRange = [1:n]';
W_N = 1/sqrt(n) * exp( i*2*pi/n );

vecR = 1 - r^2 * abs(vecLambda).^2;
vecQkjHer = (1/n) * W_N.^( (1+floor(veckRange/n)).*(1+floor(j/n)) ) .* ...
    W_N.^( (1+mod(veckRange,n)).*(1+mod(j,n)) );

vecR = vecR(:); % Make column vectors
vecQkjHer = vecQkjHer(:);

absColSum = 0; % Initialize

for indI = 1:n
    vecQik = (1/n) * conj( W_N.^( (1+floor(veckRange/n)).*(1+floor(indI/n)) ) ) .* ...
        conj( W_N.^( (1+mod(veckRange,n)).*(1+mod(indI,n)) ) );
    tmp = vecQik(:) .* vecR .* vecQkjHer;
    absColSum = absColSum + abs( sum( tmp ) );
end