% testplot: Plots the distribution of g = Laplace * N(0,1) for different a
%-------------------------------------------------------------------------------
%

vecA = [0.2 0.5 1 2 5 10];
sColour = { 'r', 'b', 'k', 'g', 'm', 'c' };

close all, figure( 1 );

x = linspace( -3, 3, 500 );

for i = 1:length( vecA )
	a = vecA( i );
	gx = 1/4 * a * exp( a^2/2 ) * ...
		( exp(a*x)  .* ( 1-erf( (x+a)/sqrt(2) ) ) + ...
		  exp(-a*x) .* ( 1+erf( (x-a)/sqrt(2) ) ) );
		
	%subplot( 2, 2, i ), plot( x, gx, 'r-' );
	%title( sprintf( 'a=%g', a ) );

	if ( i == 1 ), plot( x, gx, char( sColour(1) ) ), hold on;
	else
		plot( x, gx, char( sColour( i ) ) );
	end 

end

legend( 'a=0.1', 'a=0.5', 'a=1', 'a=2', 'a=5', 'a=10', 0 );

for i = 1:length( vecA )
	a = vecA( i );
	% Normal approximation
	mu2 = 1 + 2/(a^2);
	nx = 1/sqrt( 2*pi*mu2 ) * exp( -(x.^2) ./ (2*mu2) );
	plot( x, nx, strcat( char( sColour( i ) ), '+' )  );
end
