% tspplot: plots the exs of r-t and r-w signals for th TSP article
%-------------------------------------------------------------------------------

nPlotType = 2;

switch ( nPlotType )
case 1 % Random telegraph signal
	figure( 1 );

	% Symmetric transition probabilities
	[s,w] = system( 'mrfmsim_rtele -p tspsym.in -r sym -t dtrt -h -s -3' );
	sym_sig1 = read_tab( 'sig1.dat' );
	sym_obs1 = read_tab( 'obs1.dat' );
	obsAbsMax = max( abs( sym_obs1 ) );

	subplot( 411 ), plot( sym_sig1, 'k' );
		set( gca, 'XTick', [] );
		ylabel( '(a)', 'Rotation', 0 );
	v = axis;
	axis( [ v(1), v(2), -1.1*obsAbsMax, 1.1*obsAbsMax ] );

	subplot( 412 ), plot( sym_obs1, 'k' );
	set( gca, 'XTick', [] );
		ylabel( '(b)', 'Rotation', 0 );
	v = axis;
	axis( [ v(1), v(2), -1.1*obsAbsMax, 1.1*obsAbsMax ] );

	% Asymmetric transition probabilities
	[s,w] = system( 'mrfmsim_rtele -p tspasym.in -r asym -t dtrt -h -s -3' );
	asym_sig1 = read_tab( 'sig1.dat' );
	asym_obs1 = read_tab( 'obs1.dat' );
	obsAbsMax = max( abs( asym_obs1 ) );

	subplot( 413 ), plot( asym_sig1, 'k' );
		set( gca, 'XTick', [] );
		ylabel( '(c)', 'Rotation', 0 );
	v = axis;
	axis( [ v(1), v(2), -1.1*obsAbsMax, 1.1*obsAbsMax ] );

	subplot( 414 ), plot( asym_obs1, 'k' );
		xlabel( 'time index' );
		ylabel( '(d)', 'Rotation', 0 );
	v = axis;
	axis( [ v(1), v(2), -1.1*obsAbsMax, 1.1*obsAbsMax ] );

	print -deps2 -f1 rtele_ex.eps

case 2 % Random walk signal

	% 5 levels
	figure( 2 );
	[s,w] = system( 'mrfmsim_rwalk -p tsp5.in -r tsp5 -t rw -h -s -3' );
	lev5_sig1 = read_tab( 'sig1.dat' );
	lev5_obs1 = read_tab( 'obs1.dat' );
	obsAbsMax = max( abs( lev5_obs1 ) );

	subplot( 211 ), plot( lev5_sig1, 'k' );
		set( gca, 'XTick', [] );
		ylabel( '(a)', 'Rotation', 0 );
	v = axis;
	axis( [ v(1), v(2), -1.1*obsAbsMax, 1.1*obsAbsMax ] );

	subplot( 212 ), plot( lev5_obs1, 'k' );
		xlabel( 'time index' );
		ylabel( '(b)', 'Rotation', 0 );
	v = axis;
	axis( [ v(1), v(2), -1.1*obsAbsMax, 1.1*obsAbsMax ] );

	print -deps2 -f2 rw_ex1.eps	

	% 21 levels
	figure( 3 );
	[s,w] = system( 'mrfmsim_rwalk -p tsp21.in -r tsp21 -t rw -h -s -3' );
	lev9_sig1 = read_tab( 'sig1.dat' );
	lev9_obs1 = read_tab( 'obs1.dat' );
	obsAbsMax = max( abs( lev9_obs1 ) );

	subplot( 211 ), plot( lev9_sig1, 'k' );
		set( gca, 'XTick', [] );
		ylabel( '(a)', 'Rotation', 0 );
	v = axis;
	axis( [ v(1), v(2), -1.1*obsAbsMax, 1.1*obsAbsMax ] );

	subplot( 212 ), plot( lev9_obs1, 'k' );
		xlabel( 'time index' );
		ylabel( '(b)', 'Rotation', 0 );
	v = axis;
	axis( [ v(1), v(2), -1.1*obsAbsMax, 1.1*obsAbsMax ] );

	print -deps2 -f3 rw_ex2.eps

end
