% bnb_reorder: reorder A and x0 before using in bnb_tst
%-------------------------------------------------------------------------------
% Reorder the vector x0 so that its entries are increasing. This also means
% that we have to reorder the rows of A.
%
% [newA, newX0, T] = bnb_reorder( oldA, oldX0 )
%    old{A,X0} - old A and x0
%
% Outputs
%    new{A,X0} - new A and x0
%    T         - the transformation matrix where newX0 = T * oldX0
%
function [newA, newX0, T] = bnb_reorder( oldA, oldX0 )

n = length( oldX0 );
[newX0, ind] = sort( oldX0 );
T = zeros( n, n );
for i = 1:n
	T( i, ind(i) ) = 1;
end
newA = T * oldA * T';
