% pdb_centre: Centres a molecule around the supplied value
% 
% spinPos = pdb_centre( centreCoord, spinPosOld )
%

function spinPos = pdb_centre( centreCoord, spinPosOld )

delta = centreCoord - mean( spinPosOld );
thres = 100*eps;

if ( max( abs( delta ) ) > thres )
	warning( 'pdb_centre: spinPos is not centred at specified position' );
	spinPos = spinPosOld + repmat( delta, size(spinPosOld,1), 1 );
else
	spinPos = spinPosOld;
end

