% create_fixed_Prw: create a Prw transition matrix from the given probs
%-------------------------------------------------------------------------------
% Prw = create_fixed_Prw( M, K1, K2, H1, H2 )
%    - M = number of positive levels; total number of levels is r = 2M+1
%    - K1, K2 controls the setting of the lower quantile
%    - H1, H2 controls the ...     ...    upper ...
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Prw = create_fixed_Prw( M, K1, K2, H1, H2 )

r = 2*M + 1;
Prw = zeros( r, r );

Prw( 1, 2 ) = 1;
Prw( r, r-1 ) = 1;

for i = 2:floor( r/4 )
	Prw( i, i - 1 ) = K1;
	Prw( i, i + 1 ) = K2;
end

for i = (floor( r/4 )+1):ceil( 3*r/4 )
	Prw( i, i - 1 ) = 0.5;
	Prw( i, i + 1 ) = 0.5;
end

for i = (ceil( 3*r/4 )+1):(r-1)
	Prw( i, i - 1 ) = H1;
	Prw( i, i + 1 ) = H2;
end
