% psf_mesh_chk: check the values of the mesh structure
%-------------------------------------------------------------------------------
% bRc = psf_mesh_chk( stMesh )
%    stMesh - mesh structure
%
% Output
%    bRc    - currently not used. Rather, error() will be called.
% 
function bRc = psf_mesh_chk( stMesh ) 

bRc = 0; % Default return value

if ( ~isempty( find( stMesh.delta <= 0 ) ) )
	error( 'mesh delta must be strictly positive' )
end

if ( ~isempty( find( stMesh.numPts < 1 ) ) )
	error( 'number of mesh points in each direction must be a positive int' );
end

for numPts = stMesh.numPts
    if ( ( numPts ~= 1 ) && ( mod( numPts, 2 ) ~= 0 ) )
        error( 'number of mesh points must be 1 or an even integer' );
    end
end



