% [DEPRECIATED] psf_sim: simulation file for cantilever PSF 

% Load parameter values from another file
psf_param2

%-------------------------------------------------------------------------------
% Output due to a single spin
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Create a mesh. Note that we should avoid the origin.
[X, Y] = meshgrid( XSpan*[-1:XInc:1], YSpan*[-1:YInc:1] );
Xlen = length(X);
Ylen = length(Y);
Z = z0*ones( Xlen, Ylen );

G = zeros( Xlen, Ylen );
S = zeros( Xlen, Ylen );
P = zeros( Xlen, Ylen );

if 1
for xInd = 1:Xlen
	for yInd = 1:Ylen
		[G( xInd, yInd ), S( xInd, yInd ), P( xInd, yInd )] = ...
			psf_vert( X( xInd, yInd ), Y( xInd, yInd ), Z( xInd, yInd ), ...
			ParBext, ParBres, Parm, Parxpk, 0 );
	end
end
end %%% if 0/1

% Print out the min and max values of each matrix
Smin = min( min( S ) ); Smax = max( max( S ) );
disp( sprintf( 'Smin=%g, Smax=%g', Smin, Smax ) );
Gmin = min( min( G ) ); Gmax = max( max( G ) );
disp( sprintf( 'Gmin=%g, Gmax=%g', Gmin, Gmax ) );
Pmin = min( min( P ) ); Pmax = max( max( P ) );
disp( sprintf( 'Pmin=%g, Pmax=%g', Pmin, Pmax ) );

if 0 % Create meshc plots of S, G, P
close all;
figure( 1 ), meshc( X, Y, S ), ...
	axis equal, xlabel( 'x' ), ylabel( 'y' ); 
sTitle = sprintf( 's(x,y,z_0), z_0=%g', z0 ), title( sTitle );
figure( 2 ), meshc( X, Y, G ), ...
	axis equal, xlabel( 'x' ), ylabel( 'y' );
sTitle = sprintf( 'G(x,y,z_0), z_0=%g', z0 ), title( sTitle );
figure( 3 ), meshc( X, Y, P ), ...
	axis equal, xlabel( 'x' ), ylabel( 'y' );
sTitle = sprintf( 'PSF(x,y,z_0), z_0=%g', z0 ), title( sTitle );
sFile = sprintf( 'single_S_z0=%0.2e.jpg', z0 );
print( '-djpeg', '-f1', sFile );
sFile = sprintf( 'single_G_z0=%0.2e.jpg', z0 );
print( '-djpeg', '-f2', sFile );
sFile = sprintf( 'single_P_z0=%0.2e.jpg', z0 );
print( '-djpeg', '-f3', sFile );
end %%% if 0/1

if 0 % Create pcolor plots of S, G, P
close all; 
figure( 1 ), ...
	%subplot( 131 ), ...
	pcolor( X, Y, S ), colormap( gray ), shading interp;
	axis image;
%subplot( 132 ), ...
figure( 2 ), ...
	pcolor( X, Y, G ), colormap( gray ), shading interp;
	axis image;
%subplot( 133 ), ...
figure( 3 ), ...
	pcolor( X, Y, P ), colormap( gray ), shading interp;
	axis image;
% And save the plot to disk
%sFile = sprintf( 'single_z0=%0.2e.jpg', z0 );
%print( '-djpeg', '-f1', sFile );
sFile = sprintf( 'single_S_z0=%0.2e.jpg', z0 );
print( '-djpeg', '-f1', sFile );
sFile = sprintf( 'single_G_z0=%0.2e.jpg', z0 );
print( '-djpeg', '-f2', sFile );
sFile = sprintf( 'single_P_z0=%0.2e.jpg', z0 );
print( '-djpeg', '-f3', sFile );
close all;
end %%% if 0/1

%-------------------------------------------------------------------------------
% Output due to a multiple number of spins
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[XMult, YMult] = meshgrid( XSpan*[-spaceFac:XInc:spaceFac], ...
	YSpan*[-spaceFac:YInc:spaceFac] );
PMult = zeros( length(XMult), length(YMult) );

spinLocX = zeros( numSpins, 1 );
spinLocY = zeros( numSpins, 1 );
spinLocZ = zeros( numSpins, 1 );

for i = 1:numSpins
	% Ensure that the spin's x and y-coords don't exceed the valid range
	spinLocX( i ) = max( 1, floor( (spaceFac-1)*(Xlen-1)*rand )  );
	spinLocY( i ) = max( 1, floor( (spaceFac-1)*(Ylen-1)*rand )  );
	spinLocZ( i ) = z0 + deltaZUnc * (rand - 0.5) * 2;
end

for i = 1:numSpins % Super-impose the spin energies
	disp( sprintf( 'spin i=%g', i ) );
	xSpin = spinLocX( i );
	ySpin = spinLocY( i );
	zSpin = spinLocZ( i );
	for xInd = 1:Xlen
		for yInd = 1:Ylen
			% Re-use the arrays G, S, P. First, generate the output due to a
			% spin with a certain z value.
			[G( xInd, yInd ), S( xInd, yInd ), P( xInd, yInd )] = ...
				psf_vert( X( xInd, yInd ), Y( xInd, yInd ), zSpin, ...
				ParBext, ParBres, Parm, Parxpk, 0 );
			% Then, translate it in the x-y plane by the proper amount
			PMult( xSpin + xInd, ySpin + yInd ) = ...
				PMult( xSpin + xInd, ySpin + yInd ) + P( xInd, yInd );
		end
	end
end

PMultSize = size( PMult );
PMultAbsMax = max( max( abs( PMult ) ) );
noiseSigma = noiseSigmaFrac * PMultAbsMax;
disp( sprintf( 'PMultAbsMax=%g, noiseSigma=%g', PMultAbsMax, noiseSigma ) );
PMultMax = max( max( PMult ) );
PMultMin = min( min( PMult ) );
disp( sprintf( 'PMultMin=%g, PMultMax=%g', PMultMin, PMultMax ) );

% XXX: Add noise. Note that the noise must be non-negative, because the
%      measurement is energy.
if 0
disp( 'XXX: adding noise' );
for xInd = 1:PMultSize( 1 )
	for yInd = 1:PMultSize( 2 )
		PMult( xInd, yInd ) = PMult( xInd, yInd ) + noiseSigma*(rand)^2;
	end
end
end %%% if 0/1

if 1 % Plot
close all;
figure( 1 ); 
pcolor( XMult, YMult, PMult );
colormap( gray );
caxis( [ PMultMin, 0.5*PMultMax ] );
shading interp;
axis image;
sTitle = sprintf( 'System output of %g random spins, z_0=%g, deltaZUnc=%g', ...
	numSpins, z0, deltaZUnc ); 
title( sTitle );
xlabel( 'x' ), ylabel( 'y' );
print( '-f1', '-djpeg', 'mult.jpg' );
end %%% if 0/1
