% quad_pos_sol: pick out the positive solution of a quadratic equation
%-------------------------------------------------------------------------------
% Note that we expect one root to be non-positive and the other to be strictly
% positive. Any other scenario will result in an error.
%
% rPos = quad_pos_sol( r1, r2 )
%    r{1,2} - solutions of the quadratic eqn
%    rPos   - the positive solution
%
function rPos = quad_pos_sol( r1, r2 )
rMin = min( [r1, r2] );
rMax = max( [r1, r2] );
if ( rMin > 0 ), error( 'two positive roots' ), end;
if ( rMax <= 0 ), error( 'no positive roots' ), end;
rPos = rMax;

