% Dec 21, 2007. Check that SBL_PHI is actually the matrix representation of
% the 2d convolution represented by Gfft in the ~/work/f05/icip06/binary
% subdirectories.

% Cell array of strings copied from test_ll.m
SBL_PHI_FILE = { 'sbl_gaussian_psf.mat', ...
    '~/work/w06/tip/2d/1uud/psf_a/sbl_mrfm_psf2d64.mat', ...
    '~/work/w06/tip/2d/benz/psf_a/sbl_mrfm_psf2d64.mat', ...
    '~/work/w06/tip/2d/benz/psf_b/sbl_mrfm_psf2d64.mat' };

load( SBL_PHI_FILE{1} );

PHI = SBL_PHI;

% Assume that Gfft and xtrue exist in the current workspace
if ( ~exist( 'Gfft', 'var' ) | ~exist( 'xtrue', 'var' ) )
    error( 'Variable(s) not defined: check file' );
end

xtrueVec = xtrue(:);

yTest1 = Gfft * xtrue;
yTest2 = PHI * xtrueVec;

% Create plot comparing yTest1 and yTest2
figure( 1 ), plot( yTest1(:), 'bs' );
hold on, plot( yTest2(:), 'r>' );
legend( 'yTest1', 'yTest2', 0 );

% Compute the l_2, l_inf norm between the two vectors
szMsg = [ '|yTest1-yTest2|: l_2 = ', num2str( norm( yTest1(:)-yTest2(:), 2 ) ), ...
    ', l_inf = ', num2str( norm( yTest1(:)-yTest2(:), inf ) ) ];
disp( szMsg );