% // 2008-06-01 // Given an old image size and the factors, compute the new
% image size. Interpret a factor > 1 as upsampling and a factor < 1 as
% downsampling. Not really used now?? 
%==============================
% Args: sizeOld, resizeFactors 
% Output: sizeNew
%//////////////////////////////////////////////////////////////////////////

function sizeNew = compute_new_size( sizeOld, resizeFactors )

if ( length( sizeOld ) ~= length( resizeFactors ) )
    error( 'size mismatch for sizeOld and resizeFactors' );
end

factorNum = length( resizeFactors );
sizeNew = sizeOld; % Initialize

for factorInd = 1:factorNum
    fac = resizeFactors( factorInd );
    if ( fac > 1 )
        % Verify that fac is an integer
        if ( fac ~= round( fac ) )
            error( 'expect fac to be an integer' );
        end
        sizeNew( factorInd ) = fac * ( sizeOld( factorInd ) - 1 ) + 1;
    elseif ( fac < 1 )
        facInv = 1/fac;
        % Verify that facInv is an integer
        if ( facInv ~= round( facInv ) )
            error( 'expect facInv to be an integer' );
        end
        sizeNew( factorInd ) = round( ( sizeOld( factorInd ) - 1 ) / facInv ) + 1;
    else
        % Do nothing
    end
end