% Function to compute the COHERENCE of a dictionary. Assume that we are
% given a matrix whose columns are atoms of the dictionary. ASSUME that the
% columns have been normalized to unit norm.
% Inputs: A, nFig
% Outputs: A_mu, Acorr
function [A_mu, Acorr] = dict_coherence( A, nFig )

[ M, N ] = size( A );

% Actually, don't need the columns to have unit l_2 norm because corr
% handles that.
Acorr = corr( A );

if ( ( size( Acorr, 1 ) ~= N ) | ( size( Acorr, 2 ) ~= N ) )
    warning( 'corr returned unexpected result' );
end

AcorrDistinct = triu( Acorr, 1 );
A_mu = max( AcorrDistinct(:) );

if ( ( nargin == 2 ) & ( nFig > 0 ) )
    figure( nFig ), clf;
    layout = 210;
    subplot( layout + 1 ), imagesc( Acorr ), colorbar;
    subplot( layout + 2 ), hist( AcorrDistinct(:), 30 );
end