% // 2008-05-29 // Using the psf created, simulate an example. Contains
% ideas copied from pdb_sim_start. ASSUME that preprocfile has already been
% run.
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

SZ_CONV_TYPE = 'fft';

nFig = 0;

%xSize = [ 224+45+1, 78+15+1, (15+1)*2 ];
xSize = [ 224+45+1, 78+15+1, 28 ];

xtrue = zeros( xSize );

% Let's pick out some non-zero values in the middle and fill them.
xSizeTick{1} = round( linspace( 1, xSize(1), 4 ) );
xSizeTick{2} = round( linspace( 1, xSize(2), 4 ) );

xtrue( xSizeTick{1}(2):xSizeTick{1}(3), xSizeTick{2}(2):xSizeTick{2}(3), 1 ) = ...
    double( rand( xSizeTick{1}(3)-xSizeTick{1}(2)+1, xSizeTick{2}(3)-xSizeTick{2}(2)+1 ) > 0.98 );
disp( sprintf( 'xtrue has %g nz values', length( find( xtrue>0 ) ) ) );


mask = logical( ones( xSize ) );
Gfft = Gblur( mask, 'psf', psfMat, 'type', 'conv,fft', 'nDim', ndims(xtrue) );
Gsame = Gblur( mask, 'psf', psfMat, 'type', 'conv,same', 'nDim', ndims(xtrue) );

% Figure out the support of the psf. The idea is to go through the xy
% slices and determine the largest support

% Initialize
[ xInd, yInd ] = find( psfMat( :, :, 1 ) > 0 );
sPsf.supp{1} = [ min(xInd) max(xInd) ];
sPsf.supp{2} = [ min(yInd) max(yInd) ];

for zsliceInd = 2:size( psfMat, 3 )
    
    [ xInd, yInd ] = find( psfMat( :, :, zsliceInd ) > 0 );
    
    xIndMin = min( xInd  );
    if ( xIndMin < sPsf.supp{1}(1) ), sPsf.supp{1}(1) = xIndMin; end
    
    xIndMax = max( xInd );
    if ( xIndMax > sPsf.supp{1}(2) ), sPsf.supp{1}(2) = xIndMax; end
        
    yIndMin = min( yInd );
    if ( yIndMin < sPsf.supp{2}(1) ), sPsf.supp{2}(1) = yIndMin; end
    
    yIndMax = max( yInd );
    if ( yIndMax > sPsf.supp{2}(2) ), sPsf.supp{2}(2) = yIndMax; end
    
end

psfShiftAmount = [ -(sPsf.supp{1}(2)-sPsf.supp{1}(1))/2, ...
                   -(sPsf.supp{2}(2)-sPsf.supp{2}(1))/2, ...
                   0 ];
psfShiftAmount = ceil( psfShiftAmount );               
    
switch SZ_CONV_TYPE
    case 'fft'
        y0 = Gfft * xtrue;
        y0Display = circshift( y0, psfShiftAmount );
    case 'same'
        y0 = Gsame * xtrue;
        y0Display = y0; % No need to modify y0
    otherwise
        error( sprintf( 'unrecognized option: %s', SZ_CONV_TYPE ) );
end

nFig = nFig + 1;
plotSlices( nFig, y0Display, xSize(3), 0, 3 );