% Dec 19, 2007. Function to use in SolveStOMP. It implements the implicit
% matrix A.
%//////////////////////////////////////////////

function yOut = implicitA( GObj, objDim, mode, m, n, x, I, dim )

if ( dim ~= prod( objDim ) )
    error( sprintf( 'dim=%g but prod(objDim)=%g', dim, prod(objDim) ) );
end

switch mode
    
    case 1
        if ( length( x ) ~= n )
            error( 'unexpected length of x' );
        end
        xTmp = zeros( dim, 1 );
        xTmp( I ) = x( : );
        y = GObj * reshape( xTmp, objDim );
        yOut = y(:);
        
    case 2
        if ( length( x ) ~= m )
            error( 'unexpected length of x' );
        end
        yTmp = GObj' * reshape( x, objDim );
        y = yTmp( : );
        yOut = y( I );
        
    otherwise
        error( sprintf( 'Illegal value of mode: %g', mode ) );
        
end



