% File to write a matrix to disk. Uses the Matlab fwrite format.
% Args: A, sz_file
% Outputs: none
function matrix_dsk_write( varargin )

% Defaults
A = [];
szFilename = 'foo.bin';

% Parse arguments
nArgIn = floor( length( varargin ) / 2 );
if ( 2*nArgIn ~= length( varargin ) ), error( 'expected even # args' ), end

for argInd = 1:nArgIn
    szKey = varargin{ 2*argInd - 1 };
    ip = varargin{ 2*argInd };
    switch szKey
        case 'A', A = ip;
        case 'sz_file', szFilename = ip;
        otherwise, error( sprintf( 'unrecognized key %s', szKey ) )
    end
end

if isempty( A ), error( 'nothing to do' ), end

% Open in IEEE little endian format
fid = fopen( szFilename, 'w', 'ieee-le' );

if ( fid < 0 ), error( 'fopen failed' ), end

% Write 64-bit floating points
nWritten = fwrite( fid, A, 'real*8' );

fclose( fid );

if ( nWritten ~= numel( A ) ), error( 'could not write all elems of A' ), end

