% // 2008-06-26 // Home-brew decimation in 2d. 
%
% Args: V0, decFac, firOrder
% Output: V
%//////////////////////////////////////////////////////////////////////////

function V = mydecimate2( V0, decFac, firOrder )

if ( ndims( V0 ) ~= 2 )
    error( 'Expect V0 to have dim 2' );
end

if ( length( decFac ) ~= 2 | length( firOrder ) ~= 2 )
    error( 'Expect decFac and firOrder to have length 2' );
end

V0Size = size( V0 );
sizeRed = floor( V0Size ./ decFac );
sizeMult = decFac .* sizeRed;

% SANITY
if ( any( sizeMult > V0Size ) )
    error( 'sizeMult cannot exceed V0Size' );
end

tmp1 = zeros( sizeRed( 1 ), V0Size( 2 ) );

for yInd = 1:V0Size( 2 )
    tmp1( :, yInd ) = decimate( squeeze( V0( 1:sizeMult(1), yInd ) ), ...
        decFac( 1 ), firOrder( 1 ), 'fir' );
end

V = zeros( sizeRed( 1 ), sizeRed( 2 ) );

for xInd = 1:sizeRed( 1 )
    V( xInd, : ) = decimate( squeeze( tmp1( xInd, 1:sizeMult(2) ) ), ...
        decFac( 2 ), firOrder( 2 ), 'fir' );
end
    
