% // 2008-06-26 // Home-brew interpolation in 3d. 
%
% Args: V0, decFac
% Output: V
%//////////////////////////////////////////////////////////////////////////

function V = myinterp3( V0, decFac )

if ( ndims( V0 ) ~= 3 )
    error( 'Expect V0 to have dim 3' );
end

if ( length( decFac ) ~= 3 )
    error( 'Expect decFac to have length 3' );
end

V0Size = size( V0 );
sizeMult = decFac .* V0Size;

tmp1 = zeros( sizeMult( 1 ), V0Size( 2 ), V0Size( 3 ) );

for yInd = 1:V0Size( 2 )
    for zInd = 1:V0Size( 3 )
        tmp1( :, yInd, zInd ) = interp( squeeze( V0( :, yInd, zInd ) ), decFac( 1 ) );
    end
end

tmp2 = zeros( sizeMult( 1 ), sizeMult( 2 ), V0Size( 3 ) );

for xInd = 1:sizeMult( 1 )
    for zInd = 1:V0Size( 3 )
        tmp2( xInd, :, zInd ) = interp( squeeze( tmp1( xInd, :, zInd ) ), decFac( 2 ) );
    end
end

V = zeros( sizeMult( 1 ), sizeMult( 2 ), sizeMult( 3 ) );

for xInd = 1:sizeMult( 1 )
    for yInd = sizeMult( 2 )
        V( xInd, yInd, : ) = interp( squeeze( tmp2( xInd, yInd, : ) ), decFac( 3 ) );
    end
end
    
