% // 2008-06-01 // Zero out z-slices in an image
%=====================================
% Args: imageOld, zSliceMin, zSliceMax
% Output: imageNew
%//////////////////////////////////////////////////////////////////////////

function imageNew = zero_zslices( imageOld, zSliceMin, zSliceMax )

if ( zSliceMin > zSliceMax )
    error( 'illegal values of zSlice{Min,Max}' );
end

imageNew = imageOld;
  
if ( zSliceMin > 1 )
    if ( zSliceMin <= size( imageNew, 3 ) )
        imageNew( :, :, 1:(zSliceMin-1) ) = 0;
    else
        % Ignore zSliceMin
    end
end

if ( zSliceMax < size( imageNew, 3 ) )
    if ( zSliceMax < 1 )
        % Ignore zSliceMax
    else
        imageNew( :, :, (zSliceMax+1):end ) = 0;
    end
end