
function x = ae_posterior_med( y, a, w, sdev )

y = y(:);
n = length( y );

C = (1-w)*normpdf( y, 0, sdev ) + a*w*normcdf( (y/sdev-a*sdev), 0, 1 ).*exp(-a*y+1/2*a^2*sdev^2);
numer = (1-w)*normpdf( y, 0, sdev );
test = numer ./ C;
xPossible = y - a*sdev^2 + sdev*norminv( normcdf( -(y/sdev-a*sdev), 0, 1 ) + ...
    1/(a*w)*exp( a*y-1/2*a^2*sdev^2 ) .* ( 1/2*C - (1-w)*normpdf( y, 0, sdev ) ), ...
    0, 1 );

x = zeros( size( y ) );

for i = 1:n
    if test(i) >= 0.5, x(i) = 0;
    else
        x(i) = xPossible(i);
        if ( isnan( x(i) ) | x(i) < 0 )
            disp( sprintf( 'x(%g)=%g??', i, x(i) ) );
            error( 'quitting' );
        end
    end
end


