
% Plot estimates of aHat from verify_ahat

close all;

numHistBins = 25;

if ~exist( 'numAExp', 'var' ), numAExp = size( estAMex, 1 ); end;
if ~exist( 'numTrial', 'var' ), numTrial = size( estAMex, 2 ); end;

for indAExp = 1:numAExp

    propImage.a = aValExp( indAExp );
    propImage.t = convert_wsigma2t( propImage.a, propImage.w, propImage.sigma, ...
        'median' );

    aResult = squeeze( estAMex( indAExp, : ) );
    tResult = zeros( size( aResult ) );
    
    for indTrial = 1:numTrial
        tResult( indTrial ) = convert_wsigma2t( aResult(indTrial), ...
            propImage.w, propImage.sigma, 'median' );
    end

    if length( aResult ) ~= numTrial || length( tResult ) ~= numTrial
        error( 'unexpected number of trials' );
    end

    disp( [sprintf('          True values: a=%g, t=%g\n', ...
           propImage.a, propImage.t ), ...
           sprintf('Mean estimated values: a=%g, t=%g\n', ...
           mean(aResult), mean(tResult) )] );

    figure(1), hold off, hist( aResult, numHistBins ), hold on;
    v = axis; plot( [propImage.a, propImage.a], [v(3), v(4)], 'r' );
    title( 'a' );

    figure(2), hold off, hist( tResult, numHistBins ), hold on;
    v = axis; plot( [propImage.t, propImage.t], [v(3), v(4)], 'g' );
    title( 't' );

    disp( 'Pausing...' ), pause;

end
        
        