
% Plot estimates of aHat, wHat from verify_athat

close all;

numHistBins = 25;

for indAExp = 1:numAExp
    for indWExp = 1:numWExp
        propImage.a = aValExp( indAExp );
        propImage.w = wValExp( indWExp );
        propImage.t = tValExp( indAExp, indWExp );
        
        aResult = squeeze( estAMex( indAExp, indWExp, : ) );
        tResult = squeeze( estTMex( indAExp, indWExp, : ) );
        if length( aResult ) ~= numTrial || length( tResult ) ~= numTrial
            error( 'unexpected number of trials' );
        end
        
        wResult = zeros( size( tResult ) );
        for indTrial = 1:numTrial
           wResult( indTrial ) = convert_tsigma2w( aResult(indTrial), ...
               tResult(indTrial), propImage.sigma, 'median' );
        end
        
        disp( [sprintf('          True values: a=%g, w=%g, t=%g\n', ...
                    propImage.a, propImage.w, propImage.t ), ...
               sprintf('Mean estimated values: a=%g, w=%g, t=%g\n', ...
                    mean(aResult), mean(wResult), mean(tResult) )] );
                
        figure(1), hold off, hist( aResult, numHistBins ), hold on;
        v = axis; plot( [propImage.a, propImage.a], [v(3), v(4)], 'r' );
        title( 'a' );
        
        figure(2), hold off, hist( tResult, numHistBins ), hold on;
        v = axis; plot( [propImage.t, propImage.t], [v(3), v(4)], 'g' );
        title( 't' );
        
        figure(3), hold off, hist( wResult, numHistBins ), hold on;
        v = axis; plot( [propImage.w, propImage.w], [v(3), v(4)], 'm' );
        title( 'w' );
        
        disp( 'Pausing...' ), pause;
    end
end
        
        