
% Plot estimates of aHat, wHat from verify_athat

close all;

numHistBins = 20;

if ~exist( 'numAExp', 'var' ), numAExp = size( estAMex, 1 ); end;
if ~exist( 'numWExp', 'var' ), numWExp = size( estAMex, 2 ); end;
if ~exist( 'numSigmaExp', 'var' ), numSigmaExp = size( estAMex, 3 ); end;
if ~exist( 'numTrial', 'var' ), numTrial = size( estAMex, 4 ); end;

for indAExp = 1:numAExp
    for indWExp = 1:numWExp
        for indSigmaExp = 1:numSigmaExp
            
            propImage.a = aValExp(indAExp);
            propImage.w = wValExp(indWExp);
            propImage.sigma = sigmaValExp(indSigmaExp);
            propImage.t = convert_wsigma2t( propImage.a, propImage.w, propImage.sigma, ...
                'median' );

            aResult = squeeze( estAMex( indAExp, indWExp, indSigmaExp, : ) );
            tResult = squeeze( estTMex( indAExp, indWExp, indSigmaExp, : ) );
            sigmaResult = squeeze( estSigmaMex( indAExp, indWExp, indSigmaExp, : ) );
    
            wResult = zeros( size( aResult ) );            
            for indTrial = 1:numTrial
                wResult( indTrial ) = convert_tsigma2w( aResult(indTrial), ...
                    tResult(indTrial), sigmaResult(indTrial), 'median' );
            end
            
            disp( [sprintf('          True values: a=%g, w=%g, t=%g, sigma=%g\n', ...
                   propImage.a, propImage.w, propImage.t, propImage.sigma ), ...
                   sprintf('Mean estimated values: a=%g, w=%g, t=%g, sigma=%g\n', ...
                   mean(aResult), mean(wResult), mean(tResult), mean( sigmaResult ) )] );

           figure(1), hold off, hist( aResult, numHistBins ), hold on;
           v = axis; plot( [propImage.a, propImage.a], [v(3), v(4)], 'r' );
           title( 'a' );

           figure(2), hold off, hist( tResult, numHistBins ), hold on;
           v = axis; plot( [propImage.t, propImage.t], [v(3), v(4)], 'g' );
           title( 't' );

           figure(3), hold off, hist( wResult, numHistBins ), hold on;
           v = axis; plot( [propImage.w, propImage.w], [v(3), v(4)], 'm' );
           title( 'w' );

           figure(4), hold off, hist( sigmaResult, numHistBins ), hold on;
           v = axis; plot( [propImage.sigma, propImage.sigma], [v(3), v(4)], 'c' );
           title( 'sigma' );

           disp( 'Pausing...' ), pause;
           
        end
    end
end
        
        
