
% Script to test out new convolution method

nnz=10;
x=[ones(nnz,1);zeros(32*32-nnz,1)];
p=randperm(32*32);
x=x(p);
x=reshape(x,32,32);
xtrue = x;

tmp=[-5:1:5]';
psf=exp(-((tmp*ones(size(tmp))').^2+(ones(size(tmp))*tmp').^2)/2/2);

[imgNx, imgNy] = size( xtrue );
mask = logical(ones(imgNx, imgNy));

h = zeros( size( xtrue ) );
h( 1:size(psf,1), 1:size(psf,2) ) = psf;
bPsfMatch = 1;

Gfft = Gblur( mask, 'psf', psf, 'type', 'conv,fft' );
Gconv = Gblur( mask, 'psf', psf, 'type', 'conv,same' );

nConvMethod = 2;

switch nConvMethod
    case 1, y0 = Gfft * xtrue;
    case 2, y0 = Gconv * xtrue;
    otherwise, error( 'unrecognized nConvMethod' );
end

propNoise = struct( 'sigma', 0.1 );
randn( 'state', 0 ); % Reset state so we get the same "random" noise
yi = y0 + propNoise.sigma * randn(size(y0));

size( h )
size( xtrue )
size( psf )
figure( 1 ), imagesc( xtrue ), colorbar;
figure( 2 ), imagesc( yi ), colorbar;

[x_hat,a_hat,w_hat,sigma_hat]=map_revised(yi,psf,20000);

figure( 3 ), imagesc( x_hat ), colorbar;
