
% Script to test out the MAP1/MAP2 reconstruction methods using
% sp_img_recon and sp_img_recon2.

% Must put this here rather than in the if B_RUN_ALGOS (...) end stmt
clear all;

% Run the reconstruction algorithms
B_RUN_ALGOS = 1;

% The problem with MAP1 is that the estimate of w sometimes goes to 0!
B_RUN_MAP1 = 1;

if B_RUN_ALGOS

    sp_img_recon;
    
    try
        SZ_M_METHOD = 'map1';
        sp_img_recon2;
        sRestore4 = sRestore;
        sRestoreOptions4 = sRestoreOptions;
    catch
        B_RUN_MAP1 = 0;
        warning( 'Encountered problems with map1' );
        disp( 'Pausing...' ), pause;
    end
    
    SZ_M_METHOD = 'map2';
    G_SPECIAL = -1;
    sp_img_recon2;
    sRestore1 = sRestore;
    sRestoreOptions1 = sRestoreOptions;   

    G_SPECIAL = 1;
    sp_img_recon2;
    sRestore2 = sRestore;
    sRestoreOptions2 = sRestoreOptions;

    G_SPECIAL = (1/sqrt(2))/propImage.ampl;
    sp_img_recon2;
    sRestore3 = sRestore;
    sRestoreOptions3 = sRestoreOptions;   
    
end

disp( sprintf( 'map2, G=-1, #thres. warnings: %g', sRestoreOptions1.numThresWarning ) );
disp( sprintf( 'map2, G=1, #thres. warnings: %g', sRestoreOptions2.numThresWarning ) );
disp( sprintf( 'map2, G=1/sqrt(2)/ampl, #thres. warnings: %g', sRestoreOptions3.numThresWarning ) );
if B_RUN_MAP1
    disp( sprintf( 'map1, #thres. warnings: %g', sRestoreOptions4.numThresWarning ) );
end

hWin = 1;

% True image
figure( hWin ), clf, hWin = hWin + 1;
imagesc( xtrue ), colorbar, title( 'xtrue' );

% Reconstructions
figure( hWin ), clf, hWin = hWin + 1;
imagesc( sRestore1.last ), colorbar, title( 'map2, G = -1' );
figure( hWin ), clf, hWin = hWin + 1;
imagesc( sRestore2.last ), colorbar, title( 'map2, G = 1' );
figure( hWin ), clf, hWin = hWin + 1;
imagesc( sRestore3.last ), colorbar, title( 'map2, G = 1/sqrt(2)/ampl' );
if B_RUN_MAP1
    figure( hWin ), clf, hWin = hWin + 1;
    imagesc( sRestore4.last ), colorbar, title( 'map1' );
end

% Plot the estimates a, w, thres
figure( hWin ), clf, hWin = hWin + 1;
plot( sRestore1.hyperParamHist(:,1), 'r-' ), hold on;
plot( sRestore2.hyperParamHist(:,1), 'gx-' );
plot( sRestore3.hyperParamHist(:,1), 'b.:' );
if B_RUN_MAP1
    plot( sRestore4.hyperParamHist(:,1), 'm' );
end
title( 'a' );

figure( hWin ), clf, hWin = hWin + 1;
plot( sRestore1.hyperParamHist(:,2), 'r' ), hold on;
plot( sRestore2.hyperParamHist(:,2), 'gx-' );
plot( sRestore3.hyperParamHist(:,2), 'b.:' );
if B_RUN_MAP1
    plot( sRestore4.hyperParamHist(:,2), 'm' );
end
title( 'w' );

figure( hWin ), clf, hWin = hWin + 1;
plot( sRestore1.hyperParamHist(:,3), 'r-' ), hold on;
plot( sRestore2.hyperParamHist(:,3), 'gx-' );
plot( sRestore3.hyperParamHist(:,3), 'b.:' );
if B_RUN_MAP1
    plot( sRestore4.hyperParamHist(:,3), 'm:' );
end
title( 'thres' );