
% Script to find marginal ML estimate of "a" via grid method

aLower = propImage.a * 0.5;
aUpper = propImage.a * 1.5;
requiredDelta = 1e-3*propImage.a;
numPts = ceil( (aUpper-aLower)/requiredDelta );
aVec = linspace( aLower, aUpper, numPts );
llVal = zeros( size( aVec ) );

warning off;
for i = 1:numPts
    llVal(i) = jsLogLik( fnoisy, aVec(i), propImage.w, propImage.sigma );
end
warning on;

figure( 1 ), plot( aVec, llVal, 'rx' );
[llValMax, llValMaxInd] = max( llVal );
aHatGridReal = aVec(llValMaxInd);
disp( sprintf( 'estimate of a: %g', aHatGridReal ) );