
% hard_soft_thres: Implements the hybrid hard-soft threshold

function est = hard_soft_thres( y, phi1, phi2 )

if ( phi1 < 0 ), error( 'hard_soft_thres: phi1 < 0' ), end;
if ( ( phi2 < 0 ) | ( phi2 > phi1 ) ), error( 'hard_soft_thres: bad phi2' ), end;

pos = ( y >= phi1 ) .* ( y - phi2 );
neg = ( y <= -phi1 ) .* ( y + phi2 );
est = pos + neg;

