
% Plot the penalty function that comes from the hybrid thresholding rule.

n = 5;
tMat = zeros( n, 2 );
tMat(:,1) = ones( n, 1 );
tMat(:,2) = linspace( 0, 1, n )';

xMax = 2;
xNumPts = 5e2;
x = linspace( -xMax, xMax, xNumPts );

yMat = zeros( n, xNumPts );
y = zeros( size( x ) );

% Populate yMat
for i = 1:n
    t1 = tMat( i, 1 );
    t2 = tMat( i, 2 );
    
    for xInd = 1:xNumPts
        xVal = x( xInd );
        if ( abs(xVal) < (t1 -t2) )
            y(xInd) = -(xVal-sign(xVal)*t1)^2 + 2*t1*t2;
        else
            y(xInd) = 2*t2*abs(xVal) + t2^2;
        end
    end
    
    yMat( i, : ) = y(:)';
end

% Plot yMat
sszMarker = { 'rd-', 'k--', 'bx-', 'k.-', 'mo-' };
INC = 15;
figure( 1 ), clf;
for i = 1:n
    plot( x(1:INC:end), yMat( i, 1:INC:end ), char(sszMarker(i)), ...
        'LineWidth', 2, 'MarkerSize', 10 );
    if ( i == 1 ), hold on, end;
end
            
    