
%
% 25 Apr 2006: This had the performance numbers hard-coded. Replace by a script
% that dynamically generates the plots from the data.
%

% 1st index => l_0, l_1, l_2, nnz in estimate, xor
% 2nd index => snr 
% 3rd index => method: SBL, EB, MAP, L1
binaryS1Snr = [ 1.1, 2, 3, 1.5, 2.5 ];
binaryS1Error = zeros( 5, 5, 4 );

binaryS2Snr = [ 1.3, 2, 3, 1.5, 2.5 ];
binaryS2Error = zeros( 5, 5, 4 );

% S1 profile
%###########

% l_0 error
binaryS1Error( 1, :, : ) = [ 1024, 13, 13, 48; ...
    1024, 26, 15, 29; ...
    1024, 26, 18, 61; ...
    1024, 19, 14, 36; ...
    1024, 25, 16, 26 ...
    ];
% l_1 error
binaryS1Error( 2, :, : ) = [ 12.432, 13.148, 12.392, 7.2491; ...
    9.1305, 6.3451, 2.2028, 4.7541; ...
    8.1466, 5.2253, 2.6375, 4.8802; ...
    11.423, 5.0168, 2.1765, 5.7703; ...
    8.3145, 5.7722, 2.3422, 4.1599 ...
    ];
% l_2 error
binaryS1Error( 3, :, : ) = [ 2.3370, 3.6495, 3.5496, 1.6876; ...
    1.8180, 1.5545, 0.77439, 1.1929; ...
    1.7204, 1.2798, 0.77851, 1.0643; ...
    2.2543, 1.5038, 0.83594, 1.4050; ...
    1.7193, 1.4581, 0.78928, 1.0634 ...
    ];
% nnz
binaryS1Error( 4, :, : ) = [ 1024, 1, 2, 48; ...
    1024, 26, 15, 29; ...
    1024, 26, 18, 61; ...
    1024, 19, 14, 36; ...
    1024, 25, 16, 26 ...
    ];
% xor
binaryS1Error( 5, :, : ) = [ 46, 13, 12, 29; ...
    46, 14, 3, 15; ...
    41, 14, 6, 35; ...
    49, 7, 2, 20; ...
    43, 13, 4, 11 ...
    ];

% S2 profile
%###########

% l_0 error
binaryS2Error( 1, :, : ) = [ 1024, 36, 38, 93; ...
    1024, 55, 51, 120; ...
    1024, 66, 57, 109; ...
    1024, 43, 43, 89; ...
    1024, 60, 54, 113 ...
    ];
% l_1 error
binaryS2Error( 2, :, : ) = [ 59.133, 36, 39.177, 41.036; ...
    57.193, 37.279, 39.009, 41.277; ...
    52.424, 31.559, 27.823, 35.481; ...
    60.467, 41.489, 41.822, 39.257; ...
    55.710, 34.940, 34.559, 38.036 ...
    ];

% l_2 error
binaryS2Error( 3, :, : ) = [ 7.4634, 6, 6.5113, 5.6718; ....
    7.2346, 5.8251, 6.2278, 5.4584; ...
    6.7469, 4.7028, 4.5687, 4.9201; ...
    7.6120, 6.5870, 6.6721, 5.5136; ...
    7.0256, 5.2475, 5.6018, 5.1780 ...
    ];
% nnz
binaryS2Error( 4, :, : ) = [ 1024, 0, 4, 79; ...
    1024, 36, 29, 110; ...
    1024, 56, 48, 103; ...
    1024, 12, 13, 77; ...
    1024, 46, 40, 105 ...
    ];
% xor
binaryS2Error( 5, :, : ) = [ 80, 36, 36, 69; ...
    82, 38, 37, 88; ...
    77, 40, 30, 68; ...
    78, 38, 37, 59; ...
    81, 38, 32, 78 ...
    ];

% Plot the errors 

% Sparsity profile 1 (S1)/2 (S2)
E = binaryS1Error; 
ESnr = binaryS1Snr;
% E = binaryS2Error;
% ESnr = binaryS2Snr;

[ESnrSorted, ESnrSortedInd] = sort( ESnr, 'ascend' );
figure( 1 ), clf, figure( 2 ), clf, figure( 3 ), clf;
%szMethods = { 'SBL', 'E-EBD', 'E-MAP', 'L1-SURE' };
szMethods = { 'SBL', 'EBD-LA', 'EM-LA', 'L1-SURE' };
% Black-and-white
%szMarkers = { 'ko-.', 'ks:', 'kx--', 'k.-' };
% Colour
szMarkers = { 'ro-', 'gs-', 'bx-', 'k.-' };

for methodInd = 1:size( E, 3 )
    for perfInd = 1:size( E, 1 );
        err = squeeze( E( perfInd, :, methodInd ) );
        errSorted = err( ESnrSortedInd );
        figure( perfInd );
        switch perfInd
            case {1,4}
                semilogy( ESnrSorted(2:end), errSorted(2:end), char( szMarkers(methodInd) ) );
            otherwise
                plot( ESnrSorted(2:end), errSorted(2:end), char( szMarkers(methodInd) ) );
        end
        % Put hold on   
        if methodInd == 1, hold on, end;        
    end
end

for perfInd = 1:size( E, 1 )
    figure( perfInd );
    xlabel( 'SNR' );
    switch perfInd
        case 1, ylabel( 'l_0 of error' );
        case 2, ylabel( 'l_1 of error' );
        case 3, ylabel( 'l_2 of error' );
        case 4, ylabel( 'l_0 of estimator' );
        case 5, ylabel( 'xor criterion' );
    end
    switch perfInd
        case 5, legend( szMethods, 'Location', 'NorthWest' );           
        otherwise, legend( szMethods, 'Location', 'Best' );
    end
    figfont;
end

for perfInd = 1:size( E, 1 ), figure( perfInd ), legend, end;
    

