function [x_hat,a_hat,w_hat,sigma_hat]=map_revised(y,H,n_iter);
flag=1; %%% suppress figures (flag=0)
step_size=1;
%%%% y - matrix (n x m) - blurred noisy image
%%%% H - matrix (k x l) - forward operator
%%%% This algorithm runs faster when k*l is much smaller
%%%% than n*m (see help for conv2)
%%%% The output x has the same dimensions as y


lmax=sqrt(max(max(abs(fft2(H)).^2)));

H=H/lmax;

%%%% Constructing the adjoint of H
Had=fliplr(flipud(H));

if flag
    figure(1)
    imagesc(y);
    colormap('gray')
    colorbar
    title('Noisy Blurred Image')
end

%%% initialization
%%% soft threshold
w_hat=0.80;
x_hat=sort(y(:),'descend');
k=floor(w_hat*length(x_hat));
thresh=x_hat(k);
x_hat=(y-sign(y)*thresh).*(abs(y)>thresh);
%%% compute a,w,\sigma^2
a_hat=(1-mean(x_hat(:)==0))/mean(abs(x_hat(:)));
tmp1=y-conv2(x_hat,H,'same');
figure( 11 ), imagesc( x_hat ), colorbar, title( 'initial xhat' );
figure( 12 ), imagesc( conv2(x_hat,H,'same') ), colorbar, title( 'initial H*xhat' );
figure( 13 ), imagesc( tmp1 ), colorbar, title( 'initial tmp1' );
sigma_hat=sqrt(mean((tmp1(:)).^2));
w_hat=1-mean(x_hat(:)==0);
%%% restarting with x_hat^{(0}}=y
%x_hat=y;
if flag
    figure(3)
    imagesc(x_hat);
    colormap('gray')
    colorbar
    title('Reconstructed Image')
    a_hat,w_hat,sigma_hat
    pause
end
l=0;
fac=1;
for ctr1=1:n_iter;
    tmp1=y-conv2(x_hat,H,'same');
    z=x_hat+fac^2*conv2(tmp1,Had,'same');
    %%% MAP thresholding
    if w_hat>0.5
        t=a_hat*sigma_hat^2;
    else
        t=a_hat*sigma_hat^2+sigma_hat*sqrt(2*log((1-w_hat)/(w_hat)));
    end
    x_hat=(z-sign(z)*a_hat*sigma_hat^2).*(abs(z)>t);

    %         l=l+1;
    %         a_hat1=(1-mean(x_hat(:)==0))/mean(abs(x_hat(:)));
    %         sigma_hat1=sqrt(mean((tmp1(:)).^2));
    %         w_hat1=1-mean(x_hat(:)==0);
    %          if w_hat1>0.5
    %                t1=a_hat1*sigma_hat1^2;
    %          else
    %                 t1=a_hat1*sigma_hat1^2+sigma_hat1*sqrt(2*log((1-w_hat1)/(w_hat1)));
    %          end
    %          aa(l)=a_hat1;
    %          ss(l)=sigma_hat1;
    %          ww(l)=w_hat1;
    %     pause
    if (ctr1-1)/step_size==floor((ctr1-1)/step_size)
        if flag
            figure(3)
            imagesc(x_hat/lmax);
            colormap('gray')
            colorbar
            title('Reconstructed Image')
        end
        tmp1=y-conv2(x_hat,H,'same');
        a_hat=(1-mean(x_hat(:)==0))/mean(abs(x_hat(:)));
        sigma_hat=fac*sqrt(mean((tmp1(:)).^2));
        w_hat=1-mean(x_hat(:)==0);
        z_hat=z;
        fz1=(1-w_hat)/sqrt(2*pi*sigma_hat^2)*exp(-z_hat.^2/2/sigma_hat^2);
        fz2=a_hat*w_hat/4*( ...
            (1-erf((a_hat*sigma_hat+z_hat/sigma_hat)/sqrt(2))).*...
            exp((a_hat^2*sigma_hat^2+2*a_hat*z_hat)/2)+...
            (1+erf((-a_hat*sigma_hat+z_hat/sigma_hat)/sqrt(2))).*...
            exp((a_hat^2*sigma_hat^2-2*a_hat*z_hat)/2));
        fz=fz1+fz2;
        conf=fz2./fz;
        if flag
            figure(5)
            imagesc(conf);
            colormap('gray')
            colorbar
            title('Confidence Image')

            %         figure(6)
            %         plot(1:step_size,ww,1:step_size,aa,1:step_size,ss)
            %         l=0;
            a_hat,w_hat,sigma_hat
            pause
        end
    end
end
x_hat=x_hat/lmax
if flag
    figure(3)
    imagesc(x_hat)
    colormap('gray')
    colorbar
    title('Reconstructed Image')
end