%
% A quick and dirty way to compute the approximate slope of a function
% given values (x_i,y_i). Usage is: dy = my_slope( x, y )
%
function dy = my_slope( x, y )

[m,n] = size( y );
if ( min( n, m ) ~= 1 ), error( 'y must be a vector' ), end

yLength = max( n, m );
if ( yLength == 1 ), error( 'expect y to have length>1' ), end
dyLength = yLength - 1;

if ( n > m ), dy = zeros( 1, yLength-1 ); % y is a row vector
else, dy = zeros( yLength-1, 1 ); % y is a column vector
end

h = x(2) - x(1);

for i = 1:dyLength
    switch i
        case 1
            dy(1) = (y(2)-y(1))/h;
        case dyLength
            dy(dyLength) = (y(dyLength+1)-y(dyLength))/h;
        otherwise
            dy(i) = (y(i+1)-y(i-1))/(2*h);
    end
end