function p = probJs( varargin )

% Defaults
szType = '';
a = -1;
w = -1;
sigma = -1;
x = 0;

% Process arguments
numArgs = length( varargin )/2;
for argInd = 1:numArgs
    szKey = varargin{2*argInd-1};
    switch lower( szKey )
        case 'type', szType = varargin{2*argInd};
        case 'a', a = varargin{2*argInd};
        case 'w', w = varargin{2*argInd};
        case 'sigma', sigma = varargin{2*argInd};      
        case 'x', x = varargin{2*argInd};
        otherwise, error( sprintf( 'unrecognized key: %s', szKey ) );
    end
end

% Check arguments
if a < 0 | w < 0 | sigma < 0 | length( szType ) == 0
    error( 'invalid variable value(s)' );
end

switch lower( szType )
    case 'g'
        p = (1/4)*a*exp(0.5*a^2*sigma^2)*( 2*cosh(a*x)-exp(a*x).*erf((x+a*sigma^2)/sqrt(2)/sigma) - ...
            exp(-a*x).*erf((-x+a*sigma^2)/sqrt(2)/sigma) );
    case 'marg'
        g = (1/4)*a*exp(0.5*a^2*sigma^2)*( 2*cosh(a*x)-exp(a*x).*erf((x+a*sigma^2)/sqrt(2)/sigma) - ...
            exp(-a*x).*erf((-x+a*sigma^2)/sqrt(2)/sigma) );
        p = (1-w)*normpdf( x, 0, sigma ) + w*g;
    otherwise
        error( sprintf( 'invalid type: %s', szType ) );
end