
% Script to test sure_l1

thresVect = [ 0, logspace(-5,log10(0.2),16) ];
[sRestore, sRestoreOptions] = sure_l1( 'forward_op', psf, ...
	'noisy_output', yi, ...
	'noise_sigma', propNoise.sigma, ...
	'theta_true', xtrue, ...
	'num_em_iters', 2e4, ...
	'theta0_selector', 'Hty2', ...
	'theta0', [], ...
	'thres_interval', [0, 0.1], ...
	'thres_num_points', 11, ...
	'thres_vect', thresVect ...
	);

errl1 = zeros( size( sRestoreOptions.THRES_VECT ) );
errl2 = zeros( size( errl1 ) );

for thresInd = 1:sRestoreOptions.THRES_NUM_POINTS
	diff = xtrue(:)' - sRestore.thetaHatMat( thresInd, : );
	errl1( thresInd ) = norm( diff, 1 );
	errl2( thresInd ) = norm( diff, 2 );
end

[costMin, costMinInd] = min( sRestore.costVect );
sRestore.last = reshape( sRestore.thetaHatMat( costMinInd, : ), 32, 32 );
if 1
    figure( 1 ), clf, stem( sRestore.costVect );
    figure( 2 ), clf, imagesc( sRestore.last ), colorbar;
    disp( sprintf( 'minimizing threshold = %g', sRestoreOptions.THRES_VECT( costMinInd ) ) );
end
