
% Test the estimate of the 1-d case

diary off;
diary( 'verify_ahat.log' );

aValExp = [ 1/sqrt(2), sqrt(2), 2*sqrt(2), 4*sqrt(2) ];
numAExp = length( aValExp );

numTrial = 100;

estAGrid = zeros( numAExp, numTrial );
estAMex = zeros( size( estAGrid ) );

clear fclean fnoisy;

propImage = struct( 'n', 1e4, 'a', sqrt(2)/2, 'w', 0.1, 'sigma', 0.1 );
propImage.t = convert_wsigma2t( propImage.a, propImage.w, propImage.sigma, ...
    'median' );

for indAExp = 1:numAExp
    propImage.a = aValExp(indAExp);
    propImage.t = convert_wsigma2t( propImage.a, propImage.w, propImage.sigma, ...
        'median' );
    for indTrial = 1:numTrial
        clear fclean fnoisy;
        test_wrapper;
        estAMex( indAExp, indTrial ) = sOptim1.voptim;
        gridsearch_a;
        estAGrid( indAExp, indTrial ) = aHatGridReal;
    end
end

save verify_ahat_dat propImage *ValExp estA*;
        
diary off;