
% Test the estimate of the 2-d case

diary off;
diary( 'verify_athat.log' );

aValExp = [ 1/sqrt(2), sqrt(2), 2*sqrt(2), 4*sqrt(2) ];
wValExp = [ 0.1, 0.5, 0.8 ];

numAExp = length( aValExp );
numWExp = length( wValExp );
tValExp = zeros( numAExp, numWExp );

numTrial = 100;

estAGrid = zeros( numAExp, numWExp, numTrial );
estTGrid = zeros( size( estAGrid ) );
estAMex = zeros( size( estAGrid ) );
estTMex = zeros( size( estAGrid ) );

clear fclean fnoisy;

propImage = struct( 'n', 1e4, 'a', sqrt(2)/2, 'w', 0.1, 'sigma', 0.1 );
propImage.t = convert_wsigma2t( propImage.a, propImage.w, propImage.sigma, ...
    'median' );

for indAExp = 1:numAExp
    for indWExp = 1:numWExp
        propImage.a = aValExp(indAExp);
        propImage.w = wValExp(indWExp);
        propImage.t = convert_wsigma2t( propImage.a, propImage.w, propImage.sigma, ...
            'median' );
        tValExp( indAExp, indWExp ) = propImage.t;
        for indTrial = 1:numTrial
            clear fclean fnoisy;            
            test_wrapper;
            estAMex( indAExp, indWExp, indTrial ) = sOptim2.voptim(1);
            estTMex( indAExp, indWExp, indTrial ) = sOptim2.voptim(2);
%             gridsearch_at;
%             estAGrid( indAExp, indWExp, indTrial ) = aHatGridReal;
%             estTGrid( indAExp, indWExp, indTrial ) = tHatGridReal;
        end
    end
end

save verify_athat_dat propImage *ValExp estA* estT*;

diary off;