
% Test the estimate of the full 3-d case. Break this into several files as 
% it's so large

diary off;
diary( 'verify_atsigmahat.log' );

% aValExp = [ sqrt(2) ];
% wValExp = [ 0.1 ];
% sigmaValExp = [ 0.05, 0.1, 0.2, 0.4 ];

aValExp = [ 1/sqrt(2), sqrt(2), 2*sqrt(2) ];
%wValExp = [ 0.1, 0.5, 0.8 ];
wValExp = [0.1];
sigmaValExp = [ 0.05, 0.1, 0.2 ];

numAExp = length( aValExp );
numWExp = length( wValExp );
numSigmaExp = length( sigmaValExp );

tValExp = zeros( numAExp, numWExp, numSigmaExp );

numTrial = 100;
%numTrial = 30;

estAGrid = zeros( numAExp, numWExp, numSigmaExp, numTrial );
estTGrid = zeros( size( estAGrid ) );
estSigmaGrid = zeros( size( estAGrid ) );

estAMex = zeros( size( estAGrid ) );
estTMex = zeros( size( estAMex ) );
estSigmaMex = zeros( size( estAMex ) );

propImage = struct( 'n', 1e4 );

tic;

for indAExp = 1:numAExp
    for indWExp = 1:numWExp
        for indSigmaExp = 1:numSigmaExp
            propImage.a = aValExp(indAExp);
            propImage.w = wValExp(indWExp);
            propImage.sigma = sigmaValExp(indSigmaExp);
            propImage.t = convert_wsigma2t( propImage.a, propImage.w, propImage.sigma, ...
                'median' );
            tValExp( indAExp, indWExp, numSigmaExp ) = propImage.t;
            for indTrial = 1:numTrial
                clear fclean fnoisy;
                test_wrapper2;
                estAMex( indAExp, indWExp, indSigmaExp, indTrial ) = sOptim3.voptim(1);
                estTMex( indAExp, indWExp, indSigmaExp, indTrial ) = sOptim3.voptim(2);
                estSigmaMex( indAExp, indWExp, indSigmaExp, indTrial ) = sOptim3.voptim(3);
            end
        end
    end
end

tElapsed = toc;

save verify_atsigmahat_dat tElapsed propImage num* *ValExp est*;

diary off;