%%% Generating the original image
randn('state',1)
rand('state',0)
sigma=0.1;

nnz=10;
x=[ones(nnz,1);zeros(32*32-nnz,1)];
p=randperm(32*32);
x=x(p);
x=reshape(x,32,32);
%gen_room; %%% drawing of a room shape


n=sigma*randn(32,32);
tmp=[-5:1:5]';
H=exp(-((tmp*ones(size(tmp))').^2+(ones(size(tmp))*tmp').^2)/2/2);
%%% This line verifies the adjoint operator
%%% By usng a non symmetric H
%H=H.*((tmp*ones(size(tmp))')>0).*((ones(size(tmp))*tmp')>0);
%%%

% XXX: use Gblur
mask = logical(ones(size(x)));
Gfft = Gblur( mask, 'psf', H, 'type', 'conv,fft' );
Gconv = Gblur( mask, 'psf', H, 'type', 'conv,same' );

Gx = Gconv * x;
%Gx = Gfft * x;
y = Gx + n;
%figure( 1 ), imagesc( Gx ), colorbar, title( 'Gx' );
%figure( 2 ), imagesc( y ), colorbar, title( 'y' );
%pause;
%y=conv2(x,H,'same')+n;

figure(1)
imagesc(x);
colormap('gray')
colorbar
title('Original Image')

figure(2)
imagesc(y);
colormap('gray')
colorbar
title('Noisy Blurred Image')
tic
[x_hat,a_hat,w_hat,sigma_hat]=map_revised(y,H,20000);
toc
figure(3)

imagesc(x_hat);
colormap('gray')
colorbar
title('Reconstructed Image')
