
% Script to load files and print out reconstructions

szDataFilename = { 'sbl.mat', ...
    'eb_better_nov05.mat', ...
    'map_prior.mat', ...
    'eb_fix_w_nov05.mat',  ...
    'soft_fixed.mat', ...
    'exp1.mat', ...
    'exp2.mat', ...
    'landweb.mat' ...
    };

szPlotFilename = { 'm,recon,sbl.eps', ...
    'm,recon,ebd-la.eps', ...
    'm,recon,map-la.eps', ...
    'm,recon,ebd-l.eps', ...
    'm,recon,f-l.eps', ...
    'm,recon,e1.eps', ...
    'm,recon,e2.eps', ...
    'm,recon,lw.eps' ...
    };

n = length( szDataFilename );
m = length( szPlotFilename );
if ( n ~= m ), error( 'n not equal to m' ), end;

for i = 1:n
    szDat = char( szDataFilename(i) );
    szPlot = char( szPlotFilename(i) );
    disp( sprintf('i=%g, szDat=%s, szPlot=%s', i, szDat, szPlot ) );
    load( szDat );
    figure(1), im( reshape(sRestore.last,64,64) ), colorbar;
    print( gcf, '-depsc2', szPlot );
end