% plot_thres: Plots several thresholding functions for Dan's presentation

a=0.3;
w=0.1;
sdev=1;

y = linspace( -5, 5, 100 );
tMed = convert_wsigma2t( a, w, sdev, 'median' );

figure( 1 ), clf;
plot( y, y, 'k', 'LineWidth', 1.5 ); hold on;
plot( y, laplace_map_thres0( y, a, w, sdev ), 'b', 'LineWidth', 1.5 );
plot( y, laplace_posterior_med( y, a, tMed, sdev ), 'r', 'LineWidth', 1.5 );

legend( 'a: Landweber', 'b: EM-MAP', 'c: EM-EB', 0 );

% Set font size
setaxs = 'set(get(gca,';
fontsty = '''Fontsize'', 14);';
szCmd = [setaxs, '''xlabel''),', fontsty]
eval( szCmd );
eval( [setaxs, '''ylabel''),', fontsty] );
leg = legend;
eval( ['set(leg,', fontsty] );