% create_pie: Create pie charts
%
% Usage: create_pie( szSec )
%

function create_pie( szSec )

switch ( lower(szSec) )
case 'intro'
	numObj = 8;
case 'ctdet'
	numObj = 6;
case 'dtdet'
	numObj = 4;
case 'imgrecon'
	numObj = 2;
otherwise
	error( 'Invalid szSec' );
end

matRgbColours = [ ...
	% Pale green = #98 FB 98
	152, 251, 152;
	% Orange = #FF A5 00
	255, 165, 0;
	% Hot pink = #FF 69 B4
	255, 105, 180;
	% Deep sky blue = #00 BF FF
	0, 191, 255 ] / 256;

matCustom = [ ...
	% imgrecon
	0.595, 0.687, 1;  
	% dtdet
	1, 0.277, 0.741;	
	% ctdet
	0.489, 1, 0.547;
	% intro
	1, 0.904, 0.279 ];

sTitleColour = { 'red', 'cyan', 'green', 'yellow' };

%for i = 1:4
%	matRgbColours( i, : ) = matRgbColours( i, : ) / 256;
%end

% No. of slides in each section, with the sections being divided into
% 4 sections

numSecSlides = [ 13, 13, 14, 17 ];
numSecSlides = numSecSlides(end:-1:1);
blowout = zeros( size( numSecSlides ) );
blowout( numObj/2 ) = 1;
hPie = pie( numSecSlides, blowout, ...
	{'Sparse image recon', ...
	'DT spin detection', ...
	'CT spin detection', ...
	'Introduction to MRFM'} ...
	);
colormap( [0.7 0.7 0.7] );

for i = 2:2:8
	if ( i == numObj )
		%set( hPie(i), 'FontSize', 20, 'FontWeight', 'bold', ...
		%	'Color', char(sTitleColour(i/2)) );
		set( hPie(i), 'FontSize', 20, 'FontWeight', 'bold' );
		set( hPie(i-1), 'FaceColor', matRgbColours( i/2, : ) );
		%set( hPie(i-1), 'FaceColor', matCustom( i/2, : ) );
	else
		%set( hPie(i), 'FontSize', 16, 'Color', 'white' );
		set( hPie(i), 'FontSize', 16 );
	end
end

%set( gcf, 'Color', 'black' );

print( '-f1', '-depsc2', sprintf( '%s.eps', szSec ) );
